'use strict';
/* Controllers */

/* global passData */
/* global footerCnt */
/* global GuserInfo */
/* global deviceTimeout */
/* global prodVersion */
/* global AUSOMESPORTS_API */
/* global defaultTimer */
/* global gapi */
/* global angular */
/* global Storage */
/* global lastUpdate */
/* global updateTimer */
/* global lastSched */
/* global debugging */
/* global adCnt */
/* global prize_array */
/* global lastSetting */
/* global CLIENT_ID */



function appStartCtrl($scope, $cordovaOauth, $uibModal, $route, $http, $location, $timeout, history) {
    currentScope = $scope;
    // console.log("In AppStart");
    var tour;
    var datatype = null;
    var googleUser = {};
    var id_token = null;
    $scope.waiting = true;
    //console.log("in AppStartCtrl");
    if (platform === null) {
        document.addEventListener("deviceready", onDeviceReady, false);
        $timeout(checkDevice, 1000);
    } else {
        appStart();
    }


    // begin functions section
    function checkDevice() {
        if (platform === null) {
            if (deviceTimeout > 0) {
                deviceTimeout--;
                $timeout(checkDevice, 1000);
            } else {
                if (prodVersion === true) {
                    //   alert("Sorry, the Shop Local app is not working on this device");
                    $scope.header = "Ausome Sport";
                    $scope.message = "Sorry, the Shop Local app is not working on this device";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                } else {
                    platform = "test";
                    console.log("No device, test on browser");
                    //alert("Testing: Did not find device ready, starting test");
                    appStart();
                }
            }
        } else if (platform === "test") {
            appStart();
        }
    }

    function onDeviceReady() {
        document.addEventListener("resume", onResume, false);
        if (platform === null) {
            //         alert("found device");
            onDevice = true;
            //console.log("Phonegap onDeviceReady"); 
            platform = device.platform;
            //           alert("platform: " + platform); 

            appStart();
        }
    }
    function onResume() {
        $http.get(AUSOMESPORTS_API
                + "op=getUserUpdate&userID="
                + GuserInfo.Id)
                .then(function (data) {
                    if (data.data.talkNew.length > 0) {
                        if (currentScope.talkData) {
                            if (currentScope.fdata.userEmail === data.data.talkNew[0].userEmail) {
                                currentScope.notiTalkUpdate(currentScope.fdata);
                                return;
                            }
                        }

                        for (var i = 0; i < data.data.talkNew.length; i++) {
                            var k;
                            for (k = 0; k < passData.friend.length; k++) {
                                if (data.data.talkNew[i].userEmail === passData.friend[k].userEmail) {
                                    talkFriendSave = passData.friend[k];
                                    talkFriendSave.index = k;
                                    break;
                                }
                            }
                            data.data.talkNew[i].userName = passData.friend[k].userName;
                            if (talkNew.length > 0) {
                                var j;
                                for (j = 0; j < talkNew.length; j++) {
                                    if (talkNew[j].userEmail === data.data.talkNew[i].userEmail) {
                                        break;
                                    }
                                }
                                if (j === talkNew.length) {
                                    talkNew.push(data.data.talkNew[i]);
                                }
                            } else {
                                talkNew.push(data.data.talkNew[i]);
                            }
                        }
                        currentScope.btnLabel = "Talk back";
                        currentScope.header = talkFriendSave.userName + " is trash talking";
                        currentScope.message = "See trash talk from " + talkFriendSave.userName;
                        currentScope.type = "talk";
                        var modalInstance = $uibModal.open({
                            animation: currentScope.animationsEnabled,
                            templateUrl: 'modalNoti.html',
                            controller: ModalInstanceCtrl,
                            scope: currentScope
                        });
                        modalInstance.result.then(function (data) {
                            if (data === "ok") {
                                $route.reload();
                            }
                        }, function (data) {
                            $route.reload();
                        });
                    }
                }, function (data) {
                });
    }

    function appStart() {
        if (platform === "Android") {
            var mvp = document.getElementById("viewport");
            mvp.setAttribute("content", "width=device-width");
        }
        if (localStorage.SaveUserInfo) {
            var SaveUserInfo = localStorage.SaveUserInfo;
            GuserInfo = angular.fromJson(SaveUserInfo);
            if (GuserInfo.AppVersion) {
                if (GuserInfo.AppVersion === appVersion) {
                    tour = false;
                } else {
                    tour = true;
                    GuserInfo.AppVersion = appVersion;
                    var SaveUserInfo = angular.toJson(GuserInfo);
                    localStorage.SaveUserInfo = SaveUserInfo;
                }
            } else {
                GuserInfo.Id = "...";
                tour = true;
                GuserInfo.AppVersion = appVersion;
                var SaveUserInfo = angular.toJson(GuserInfo);
                localStorage.SaveUserInfo = SaveUserInfo;
            }
            if (GuserInfo.Id !== "...") {
                datatype = "ID";
                id_token = GuserInfo.Id;
                recentTime = localStorage.recentTime;
            }
        } else {
            tour = true;
            var SaveUserInfo = angular.toJson(GuserInfo);
            localStorage.SaveUserInfo = SaveUserInfo;
        }
        if (tour) {
            tour = false;
            $location.path("/tour");
            return;
        }
        if (datatype === null) {
            // startApp();
            $scope.waiting = false;
            if (!onDevice) {
                startApp();
            }
        } else {
            //  alert("appstart datatype is "+datatype);
            getUserInfo();
        }
    }
    function setUserInfo(res) {
        GuserInfo.Type = "Google";
        GuserInfo.Id = res.data.names[0].metadata.source.id;
        GuserInfo.Name = res.data.names[0].displayName;
        GuserInfo.GivenName = res.data.names[0].givenName;
        GuserInfo.FamilyName = res.data.names[0].familyName;
//        GuserInfo.ImageUrl = res.data.photos[0].url;
        GuserInfo.Email = res.data.emailAddresses[0].value;
        datatype = "token";
        GuserInfo.Token = id_token;
        var SaveUserInfo = angular.toJson(GuserInfo);
        localStorage.SaveUserInfo = SaveUserInfo;
        //  alert("setuserinfo calling get userinfo");
        getUserInfo();
    }
    $scope.googleLogin = function () {
        if (!onDevice)
            return;
        $cordovaOauth.google(CLIENT_ID, ["email", "profile", "https://www.googleapis.com/auth/contacts.readonly"])
                .then(function (result) {
                    //       alert("cordova auth success");
                    id_token = result.id_token;
                    access_token = result.access_token;
                    $http.get("https://people.googleapis.com/v1/people/me",
                            {params: {access_token: result.access_token,
                                    personFields: 'names,emailAddresses'}})
                            .then(function (res) {
                                //             alert("res is: " + JSON.stringify(res));
                                setUserInfo(res);
                            }, function (error) {
                                // alert("Error: " + JSON.stringify(error));
                                $scope.header = "User sign in";
                                $scope.message = "Sorry, there was a problem signing in, please try again";
                                var modalInstance = $uibModal.open({
                                    animation: $scope.animationsEnabled,
                                    templateUrl: 'modalOK.html',
                                    controller: ModalInstanceCtrl,
                                    scope: $scope
                                });
                            });
                    $scope.waiting = true;
                }, function (error) {
                    // alert("cordova auth error: " + error);
                    $scope.header = "User sign in";
                    $scope.message = "Sorry, there was a problem signing in, please try again";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                });
    };
    function startApp() {
        $scope.waiting = false;
        // console.log("do gapi load");
        gapi.load('auth2', function () {
            //console.log("in gapi load callback");
            // Retrieve the singleton for the GoogleAuth library and set up the client.
            auth2 = gapi.auth2.init({
                client_id: CLIENT_ID,
                'scope': 'https://www.googleapis.com/auth/plus.login'
                        //             client_id: '650139415712-gc1je1eauhul0j4fod08j01qgdah22nn.apps.googleusercontent.com',
                        //            cookie_policy: 'single_host_origin'
                        // Request scopes in addition to 'profile' and 'email'
                        //scope: 'additional_scope'
            });
            if (auth2.isSignedIn.get()) {
                //console.log("already signed in");
                auth2.signIn();
            } else {
                //console.log("not signed in");
                attachSignin(document.getElementById('customBtn'));
            }
        });
        function signinChanged(val) {
            //console.log('Signin state changed to ', val);
        }
        ;
        function userChanged(user) {
            //console.log('User now: ', user);
        }
        ;
    }
    ;
    function attachSignin(element) {
        //console.log(element.id);
        auth2.attachClickHandler(element, {},
                function (googleUser) {
                    $scope.waiting = true;
                    var authResp = googleUser.getAuthResponse();
                    id_token = authResp.id_token;
                    access_token = authResp.access_token;
                    $http.get("https://people.googleapis.com/v1/people/me",
                            {params: {access_token: access_token,
                                    personFields: 'names,emailAddresses'}})
                            .then(function (res) {
                                setUserInfo(res);
                            }, function (error) {
                                //  alert("Error: " + JSON.stringify(error));
                                $scope.header = "User sign in";
                                $scope.message = "Sorry, there was a problem signing in, please try again";
                                var modalInstance = $uibModal.open({
                                    animation: $scope.animationsEnabled,
                                    templateUrl: 'modalOK.html',
                                    controller: ModalInstanceCtrl,
                                    scope: $scope
                                });
                            });
                }, function (error) {
            $scope.header = "Sign in";
            $scope.message = "Oops, there was a problem in the sign in process, please try again";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            startApp();
        });
    }

    function getUserInfo() {
        //      alert("in getUserInfo");
        //console.log("get user info");
        var postData = "{\"userData\":{";
        postData = postData.concat("\"id_token\":\"" + id_token + "\"");
        postData = postData.concat("}}");
        $http.post(AUSOMESPORTS_API + "op=userInfo&type=Google&datatype=" + datatype, postData).
                then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    //     console.log("success goes here");
                    passData = data.data;
                    if (passData.friend) {
                        for (var i = 0; i < passData.friend.length; i++) {
                            passData.friend[i].index = i;
                        }
                    }
                    if (onDevice) {
                        //           if (platform === "Android") {
                        //    alert("doing push init");
                        var push = PushNotification.init({
                            android: {
                                senderID: "650139415712"
                            },
                            browser: {
                                pushServiceURL: 'http://push.api.phonegap.com/v1/push'
                            },
                            ios: {
                                alert: "true",
                                badge: true,
                                sound: 'false'
                            },
                            windows: {}
                        });
                        PushNotification.hasPermission(function (data) {
                            //     if (data.isEnabled) {
                            //        alert('isEnabled ' + data.isEnabled);
                            push.on('registration', function (data) {
                                //           alert("regID: " + data.registrationId);
                                nidSave = data.registrationId;
                                $http.get(AUSOMESPORTS_API
                                        + "op=setNotification&userID="
                                        + GuserInfo.Id
                                        + "&notificationID="
                                        + data.registrationId
                                        + "&platform="
                                        + platform)
                                        .then(function (data) {
                                        }, function (data) {
                                        });
                            });
                            push.on('notification', function (data) {
                                onNotificationGCM(data);
                            });
                            //     } else {
                            //        alert('push not enabled');
                            //    }
                        });

                        //          }
                    }
                    footerSel = 0;
                    $location.path("/homePage");
                }, function (data) {
                    $scope.header = "User sign in";
                    $scope.message = "Sorry, there was a problem signing in, please try again";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                    datatype = null;
                    startApp();
                });
    }
    function onNotificationGCM(data) {
        // alert("Notification data: " + JSON.stringify(data));
        //    alert(data.title);
        //    alert(data.message);
        switch (data.additionalData.addData.type) {
            case "challenge":
            case "accept":
                currentScope.btnLabel = "See Challenges";
                break;
            case "talk":
                if (currentScope.talkData) {
                    data.additionalData.addData.type = "talkNow";
                    if (currentScope.fdata.userEmail === data.additionalData.addData.email) {
                        currentScope.notiTalkUpdate(currentScope.fdata);
                        return;
                    }
                }
                for (var i = 0; i < passData.friend.length; i++) {
                    if (data.additionalData.addData.email === passData.friend[i].userEmail) {
                        talkFriendSave = passData.friend[i];
                        talkFriendSave.index = i;
                        //set trash talk flag and save new
                        var j;
                        if (talkNew.length > 0) {
                            for (j = 0; j < talkNew.length; j++) {
                                if (talkNew[j].userEmail === passData.friend[i].userEmail) {
                                    break;
                                }
                                if (j === talkNew.length) {
                                    talkNew.push(passData.friend[i]);
                                }
                            }
                        } else {
                            talkNew.push(passData.friend[i]);
                        }
                        break;
                    }
                }
                //            $route.reload();
                currentScope.btnLabel = "Talk back";
                break;
        }
        currentScope.header = data.title;
        currentScope.message = data.message;
        currentScope.type = data.additionalData.addData.type;
        var modalInstance = $uibModal.open({
            animation: currentScope.animationsEnabled,
            templateUrl: 'modalNoti.html',
            controller: ModalInstanceCtrl,
            scope: currentScope
        });
        modalInstance.result.then(function (result) {
            if (data.additionalData.addData.type === "talkNow" && result === "redirect") {
                $route.reload();
            }
        }, function (result) {
        });
    }
}
function homePageCtrl($scope, $location, $route, $timeout) {
    ctrlInit("Ausome Sports", $scope, $location, $route, $timeout);
    $scope.showActivity = false;
    $scope.activity = [];
    $scope.showSeeChallenges = false;
    $scope.showNothing = true;
    var dateNow = new Date();
    var timeNow = dateNow.getTime();
    var useTimer = timeNow - defaultTimer;
    if (recentTime) {
        if (useTimer > recentTime) {
            useTimer = recentTime;
        }
    }
    recentTime = timeNow;
    localStorage.recentTime = recentTime;
    $scope.challengeMsg = [];
    if (passData.myChallenge) {
        for (var i = 0; i < passData.myChallenge.length; i++) {
            var pickDate = new Date(passData.myChallenge[i].date);
            var pickTime = pickDate.getTime();
            if (passData.myChallenge[i].result !== "tbd" &&
                    passData.myChallenge[i].status === "accepted" &&
                    pickTime > useTimer) {
                $scope.showActivity = true;
                passData.myChallenge[i].catImg = "img/myChallenges.png";
                if (passData.myChallenge[i].myPick === passData.myChallenge[i].result) {
                    passData.myChallenge[i].resultMsg = passData.myChallenge[i].prize +
                            " from " +
                            passData.myChallenge[i].opponentName;
                    passData.myChallenge[i].resultImg = "img/trophy.png";
                } else {
                    passData.myChallenge[i].resultMsg = passData.myChallenge[i].prize +
                            " to " +
                            passData.myChallenge[i].opponentName;
                    passData.myChallenge[i].resultImg = "img/sadFace.png";
                }
                passData.myChallenge[i].showMyPickCheck = true;
                activityInsert(passData.myChallenge[i]);
                //  $scope.activity.unshift(passData.myChallenge[i]);
            }
            if (passData.myChallenge[i].responseSeen === "no" &&
                    (passData.myChallenge[i].status === "accepted" ||
                            passData.myChallenge[i].status === "rejected")) {
                passData.myChallenge[i].responseSeen = "yes";
                var msg = {msg: passData.myChallenge[i].opponentName
                            + " " + passData.myChallenge[i].status + " your challenge: ",
                    sportUrl: passData.myChallenge[i].sportUrl,
                    myPickURL: passData.myChallenge[i].myPickURL,
                    oppPickURL: passData.myChallenge[i].oppPickURL};
                $scope.challengeMsg.push(msg);
            }
        }
    }
    if (passData.challenged) {
        for (var i = 0; i < passData.challenged.length; i++) {
            var pickDate = new Date(passData.challenged[i].date);
            var pickTime = pickDate.getTime();
            if (passData.challenged[i].result !== "tbd" &&
                    passData.challenged[i].status === "accepted" &&
                    pickTime > useTimer) {
                $scope.showActivity = true;
                passData.challenged[i].catImg = "img/theirChallenges.png";
                if (passData.challenged[i].oppPick === passData.challenged[i].result) {
                    passData.challenged[i].resultMsg = passData.challenged[i].prize +
                            " from " +
                            passData.challenged[i].challengerName;
                    passData.challenged[i].resultImg = "img/trophy.png";
                } else {
                    passData.challenged[i].resultMsg = passData.challenged[i].prize +
                            " to " +
                            passData.challenged[i].challengerName;
                    passData.challenged[i].resultImg = "img/sadFace.png";
                }
                passData.challenged[i].showMyPickCheck = false;
                activityInsert(passData.challenged[i]);
                //   $scope.activity.unshift(passData.challenged[i]);
            }
            if (passData.challenged[i].challengeSeen === "no") {
                passData.challenged[i].challengeSeen = "yes";
                var msg = {msg: passData.challenged[i].challengerName
                            + " has sent you a challenge: ",
                    sportUrl: passData.challenged[i].sportUrl,
                    myPickURL: passData.challenged[i].myPickURL,
                    oppPickURL: passData.challenged[i].oppPickURL};
                $scope.challengeMsg.push(msg);
                $scope.showSeeChallenges = true;
            }
        }
    }
    if (passData.picks) {
        $scope.showNothing = false;
        for (var i = 0; i < passData.picks.length; i++) {
            var pickDate = new Date(passData.picks[i].date);
            var pickTime = pickDate.getTime();
            if (passData.picks[i].result !== "tbd" && pickTime > useTimer) {
                $scope.showActivity = true;
                passData.picks[i].catImg = "img/myPicks.png";
                if (passData.picks[i].myPick === passData.picks[i].result) {
                    passData.picks[i].resultMsg =
                            "";
                    passData.picks[i].resultImg = "img/trophy.png";
                } else {
                    passData.picks[i].resultMsg =
                            "";
                    passData.picks[i].resultImg = "img/sadFace.png";
                }
                passData.picks[i].showMyPickCheck = true;
                activityInsert(passData.picks[i]);
                //  $scope.activity.unshift(passData.picks[i]);
            }
        }
    }
    $scope.stats = {
        picks: "",
        myChallenge: "",
        challenged: ""
    };
    passData.statSport = [];
    if (passData.picks) {
        $scope.stats.picks = pickInfo();
    }
    adCnt.pick = $scope.stats.picks.total;
    if (passData.myChallenge) {
        $scope.stats.myChallenge = challengeInfo(passData.myChallenge);
        if ($scope.stats.myChallenge.acceptedTotal > 0)
            $scope.showNothing = false;
    }
    adCnt.cha = $scope.stats.myChallenge.acceptedTotal;
    if (passData.challenged) {
        $scope.stats.challenged = challengeInfo(passData.challenged);
        if ($scope.stats.challenged.acceptedTotal > 0)
            $scope.showNothing = false;
    }
    angular.element(document).ready(function () {
        //Angular breaks if this is done earlier than document ready.
        var labels = [
            "right",
            "wrong",
            "tbd  "
        ];
        var data = [$scope.stats.picks.right,
            $scope.stats.picks.wrong,
            $scope.stats.picks.tbd];
        var colors = [
            "#008000",
            "#ff0000",
            "#ffff00"
        ];
        chartStats("Picks", labels, data, colors, colors);
        labels = [
            "won  ",
            "lost ",
            "tbd  "
        ];
        data = [$scope.stats.myChallenge.acceptedRight,
            $scope.stats.myChallenge.acceptedWrong,
            $scope.stats.myChallenge.acceptedTbd];
        chartStats("MyChallenge", labels, data, colors, colors);
        data = [$scope.stats.challenged.acceptedWrong,
            $scope.stats.challenged.acceptedRight,
            $scope.stats.challenged.acceptedTbd];
        chartStats("Challenged", labels, data, colors, colors);
    });
    $scope.data = passData;

    // begin functions
    function activityInsert(pick) {
        var cmp;
        var added = false;
        var len = $scope.activity.length;
        for (var i = 0; i < len; i++) {
            cmp = (pick.date > $scope.activity[i].date ? -1 : (pick.date < $scope.activity[i].date ? 1 : 0));
            if (cmp === 1) {
                continue;
            } else {
                $scope.activity.splice(i, 0, pick);
                added = true;
                break;
            }
        }
        if (!added) {
            $scope.activity.push(pick);
        }
    }
}
function statsCtrl($scope, $location, $uibModal, $timeout, $route) {
    ctrlInit("Stats", $scope, $location, $route, $timeout);
    $scope.stats = {
        picks: "",
        myChallenge: "",
        challenged: ""};
    $scope.topics = [
        "Picks",
        "My Challenge",
        "Challenged"];
    var tabCnt = 3;
    $scope.tab = tabInit(tabCnt, lastSetting.statsTab, "tab");
    $scope.tabClick = function (tabNumber) {
        lastSetting.statsTab = tabNumber;
        tabDisplay($scope, tabNumber, "tab");
    };
    $scope.nextTab = function () {
        nextTab($scope, lastSetting.statsTab, tabCnt);
//        var tabNumber = (lastSetting.statsTab + 1) % tabCnt;
//        $scope.tabClick(tabNumber);
    };
    $scope.prevTab = function () {
        prevTab($scope, lastSetting.statsTab, tabCnt);
//        var tabNumber = 0;
//        if (lastSetting.statsTab === 0) {
//            tabNumber = tabCnt - 1;
//        } else {
//            tabNumber = (lastSetting.statsTab - 1) % tabCnt;
//        }
//        $scope.tabClick(tabNumber);
    };
    // sports tab information
    if (passData.picks) {
        $scope.stats.picks = pickInfo();
    }
    if (passData.challenged) {
        $scope.stats.challenged = challengeInfo(passData.challenged);
    } else {
        $scope.stats.challenged = challengeInfo(null);
    }
    if (passData.myChallenge) {
        $scope.stats.myChallenge = challengeInfo(passData.myChallenge);
    } else {
        $scope.stats.myChallenge = challengeInfo(null);
    }
    $scope.statSport = passData.statSport;
    $scope.sportUrl = [];
    for (var i = 0; i < $scope.statSport.length; i++) {
        $scope.sportUrl.push(findSportUrl($scope.statSport[i]));
    }
    // friend tab information
    $scope.resultMsg = "See Results";
    $scope.friendInfo = false;
    $scope.fdata = {userName: ""};
    $scope.friendsData = {friend: ""};
    $scope.friendsData.friend = passData.friend;
    $scope.friendSelect = function () {
        $scope.imageArea = [false, false];
        $scope.imageAreaSrc = ["img/expand.png", "img/expand.png"];
        //console.log('found userName ' + $scope.fdata.userName);
        for (var i = 0; i < passData.friend.length; i++) {
            if ($scope.fdata.userName === passData.friend[i].userName) {
                $scope.fdata.userEmail = passData.friend[i].userEmail;
                break;
            }
        }
        if ($scope.fdata.userEmail) {
            $scope.f = {
                myChallenge: [],
                myChallengeData: "",
                challenged: [],
                challengedData: ""};
            // friends that I challenged
            if (passData.myChallenge) {
                for (var i = 0; i < passData.myChallenge.length; i++) {
                    if ($scope.fdata.userEmail === passData.myChallenge[i].opponentEmail) {
                        if (passData.myChallenge[i].status === "accepted"
                                && passData.myChallenge[i].result !== "tbd") {
                            if (passData.myChallenge[i].myPick === passData.myChallenge[i].result) {
                                passData.myChallenge[i].resultImg = "img/trophy.png";
                                $scope.f.myChallenge.unshift(passData.myChallenge[i]);
                            } else if (passData.myChallenge[i].oppPick === passData.myChallenge[i].result) {
                                passData.myChallenge[i].resultImg = "img/sadFace.png";
                                $scope.f.myChallenge.unshift(passData.myChallenge[i]);
                            }
                        }
                    }
                }
                if ($scope.f.myChallenge.length > 0) {
                    $scope.f.myChallengeData = challengeInfo($scope.f.myChallenge);
                    $scope.friendInfo = true;
                }
            }
            if ($scope.f.myChallengeData === "") {
                $scope.f.myChallengeData = challengeInfo(null);
            }
            // friends that challenged me
            if (passData.challenged) {
                for (var i = 0; i < passData.challenged.length; i++) {
                    if ($scope.fdata.userEmail === passData.challenged[i].challengerEmail) {
                        if (passData.challenged[i].status === "accepted"
                                && passData.challenged[i].result !== "tbd") {
                            if (passData.challenged[i].myPick === passData.challenged[i].result) {
                                passData.challenged[i].resultImg = "img/sadFace.png";
                            } else {
                                passData.challenged[i].resultImg = "img/trophy.png";
                            }
                            $scope.f.challenged.unshift(passData.challenged[i]);
                        }
                    }
                }
                if ($scope.f.challenged.length > 0) {
                    $scope.f.challengedData = challengeInfo($scope.f.challenged);
                    $scope.friendInfo = true;
                }
            }
            if ($scope.f.challengedData === "") {
                $scope.f.challengedData = challengeInfo(null);
            }
            if ($scope.f.challenged.length + $scope.f.myChallenge.length === 0) {
                $scope.friendInfo = false;
                $scope.resultMsg = "No challenges found for " + $scope.fdata.userName;
                return;
            }
        }

        angular.element(document).ready(function () {
            var chart = "MyChart-friend";
            var ctx = document.getElementById(chart);
            var data = {
                labels: [
                    "won",
                    "lost"
                ],
                datasets: [
                    {
                        data: [$scope.f.myChallengeData.acceptedRight + $scope.f.challengedData.acceptedWrong,
                            $scope.f.myChallengeData.acceptedWrong + $scope.f.challengedData.acceptedRight],
                        backgroundColor: [
                            "#008000",
                            "#ff0000"
                        ],
                        hoverBackgroundColor: [
                            "#008000",
                            "#ff0000"
                        ]
                    }]
            };
            var myChart = new Chart(ctx, {
                type: 'pie',
                data: data,
                options: {
                    legend: {
                        fullWidth: true,
                        labels: {
                            boxWidth: 10
                        }
                    }
                },
                animation: {
                    animateRotate: true}
            });
            myChart.render();
        });
    };
    // friend tab details, expand and shrink list
    $scope.imageArea = [false, false];
    $scope.imageAreaSrc = ["img/expand.png", "img/expand.png"];
    $scope.showArea = function (area) {
        if ($scope.imageArea[area]) {
            $scope.imageArea[area] = false;
            $scope.imageAreaSrc[area] = "img/expand.png";
        } else {
            $scope.imageArea[area] = true;
            $scope.imageAreaSrc[area] = "img/shrink.png";
        }
    };
    $scope.inlineOptions = {
        customClass: getDayClass,
        minDate: new Date(),
        showWeeks: true
    };
    $scope.dateOptions = {
        showWeeks: false,
        formatYear: 'yy',
        maxDate: new Date(2020, 5, 22),
        minDate: new Date(),
        startingDay: 1
    };
    $scope.toggleMin = function () {
        $scope.inlineOptions.minDate = $scope.inlineOptions.minDate ? null : new Date();
        $scope.dateOptions.minDate = $scope.inlineOptions.minDate;
    };
    $scope.toggleMin();
    $scope.openStart = function () {
        $scope.popupStart.opened = true;
    };
    $scope.openEnd = function () {
        $scope.popupEnd.opened = true;
    };
    $scope.dtStartStr = "";
    $scope.dtEndStr = "";
    $scope.dateMsg = "ok";
    $scope.showResults = false;
    $scope.gotStartDate = function () {
        var dt = new Date();
        var dtStr = dateToString(dt);
        $scope.dtEndStr = "";
        $scope.dtStartStr = dateToString($scope.dtStart);
        if ($scope.dtStartStr > dtStr) {
            $scope.dateMsg = "Start date can not be in the future";
            $scope.dtStartStr = "";
            return;
        } else {
            $scope.dtEnd = null;
            $scope.dateMsg = "ok";
        }
    };
    $scope.gotEndDate = function () {
//        dtSave = $scope.dt;
        $scope.dtEndStr = dateToString($scope.dtEnd);
//        callGamesAPI(gameDay);
//        console.log("dtStart " + $scope.dtEndStr);
        if ($scope.dtStartStr !== "") {
            if ($scope.dtEndStr >= $scope.dtStartStr) {
                $scope.dateMsg = "ok";
            } else {
                $scope.dateMsg = "End date can not be before the start date";
                $scope.dtEndStr = "";
                $scope.showResults = false;
                return;
            }
        } else {
            $scope.dtEndStr = "";
            $scope.dateMsg = "Please choose a start date";
            $scope.showResults = false;
            return;
        }
        $scope.gameList = [];
        $scope.picksRight = 0;
        $scope.picksWrong = 0;
        for (var i = 0; i < passData.picks.length; i++) {
            if (passData.picks[i].date >= $scope.dtStartStr &&
                    passData.picks[i].date <= $scope.dtEndStr) {
                if (passData.picks[i].myPick === passData.picks[i].result) {
                    passData.picks[i].resultImg = "img/trophy.png";
                    $scope.picksRight++;
                    $scope.gameList.push(passData.picks[i]);
                } else if (passData.picks[i].oppPick === passData.picks[i].result) {
                    passData.picks[i].resultImg = "img/sadFace.png";
                    $scope.picksWrong++;
                    $scope.gameList.push(passData.picks[i]);
                }
            }
        }
        if ($scope.gameList.length > 0) {
            $scope.showResults = true;
        } else {
            $scope.showResults = false;
            $scope.dateMsg = "No games found for the date range";
        }
    };
    function dateToString(dateObj) {
        var yr = (dateObj.getFullYear()).toString();
        var moNum = (dateObj.getMonth()) + 1;
        var mo = moNum.toString();
        if (moNum < 10) {
            mo = "0".concat(mo);
        }
        var daNum = (dateObj.getDate());
        var da = daNum.toString();
        if (daNum < 10) {
            da = "0".concat(da);
        }
        var dateStr = yr.concat("-").concat(mo).concat("-").concat(da);
        return dateStr;
    }
    $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
    $scope.format = $scope.formats[0];
    $scope.altInputFormats = ['M!/d!/yyyy'];
    $scope.popupStart = {
        opened: false
    };
    $scope.popupEnd = {
        opened: false
    };
    var tomorrow = new Date();
    tomorrow.setDate(tomorrow.getDate() + 1);
    var afterTomorrow = new Date();
    afterTomorrow.setDate(tomorrow.getDate() + 1);
    $scope.events = [
        {
            date: tomorrow,
            status: 'full'
        },
        {
            date: afterTomorrow,
            status: 'partially'
        }
    ];
    function getDayClass(data) {
        var date = data.date,
                mode = data.mode;
        if (mode === 'day') {
            var dayToCheck = new Date(date).setHours(0, 0, 0, 0);
            for (var i = 0; i < $scope.events.length; i++) {
                var currentDay = new Date($scope.events[i].date).setHours(0, 0, 0, 0);
                if (dayToCheck === currentDay) {
                    return $scope.events[i].status;
                }
            }
        }
        return '';
    }
// date picker code end

    var order = [1, 1, 1, 1, 1];
    $scope.sort = function (col) {
        order[col] = -order[col];
        switch (col) {
            case 0:
                $scope.gameList.sort(function (a, b) {
                    var nameA = a.date.toLowerCase(), nameB = b.date.toLowerCase();
                    if (nameA < nameB) //sort string ascending
                        return order[col];
                    if (nameA > nameB)
                        return -order[col];
                    return 0; //default return value (no sorting)
                });
                break;
            case 1:
                $scope.gameList.sort(function (a, b) {
                    var nameA = a.sportUrl.toLowerCase(), nameB = b.sportUrl.toLowerCase();
                    if (nameA < nameB) //sort string ascending
                        return order[col];
                    if (nameA > nameB)
                        return -order[col];
                    return 0; //default return value (no sorting)
                });
                break;
            case 2:
                $scope.gameList.sort(function (a, b) {
                    var nameA = a.myPick.toLowerCase(), nameB = b.myPick.toLowerCase();
                    if (nameA < nameB) //sort string ascending
                        return order[col];
                    if (nameA > nameB)
                        return -order[col];
                    return 0; //default return value (no sorting)
                });
                break;
            case 3:
                $scope.gameList.sort(function (a, b) {
                    var nameA = a.oppPick.toLowerCase(), nameB = b.oppPick.toLowerCase();
                    if (nameA < nameB) //sort string ascending
                        return order[col];
                    if (nameA > nameB)
                        return -order[col];
                    return 0; //default return value (no sorting)
                });
                break;
            case 4:
                $scope.gameList.sort(function (a, b) {
                    var nameA = a.resultImg.toLowerCase(), nameB = b.resultImg.toLowerCase();
                    if (nameA < nameB) //sort string ascending
                        return order[col];
                    if (nameA > nameB)
                        return -order[col];
                    return 0; //default return value (no sorting)
                });
                break;
        }
    };


    // need to wait for page ready before drawing first charts
    angular.element(document).ready(function () {
        //Angular breaks if this is done earlier than document ready.
        var right, wrong;
        var label1, label2;
        for (var i = 0; i < $scope.statSport.length; i++) {
            for (var j = 0; j < $scope.topics.length; j++) {
                if (j === 0) {
                    right = $scope.stats.picks.sportRight.get($scope.statSport[i]);
                    wrong = $scope.stats.picks.sportWrong.get($scope.statSport[i]);
                    label1 = "Right ";
                    label2 = "Wrong ";
                } else if (j === 1) {
                    right = $scope.stats.myChallenge.sportRight.get($scope.statSport[i]);
                    wrong = $scope.stats.myChallenge.sportWrong.get($scope.statSport[i]);
                    label1 = "Won  ";
                    label2 = "Lost ";
                } else if (j === 2) {
                    wrong = $scope.stats.challenged.sportRight.get($scope.statSport[i]);
                    right = $scope.stats.challenged.sportWrong.get($scope.statSport[i]);
                    label1 = "Won  ";
                    label2 = "Lost ";
                } else
                    return;
                if (!right) {
                    right = 0;
                }
                if (!wrong) {
                    wrong = 0;
                }
                var chart = "MyChart-";
                chart = chart.concat(i + "-" + j);
                var ctx = document.getElementById(chart);
                var data = {
                    labels: [
                        label1 + right,
                        label2 + wrong
                    ],
                    datasets: [
                        {
                            data: [right, wrong],
                            backgroundColor: [
                                "#008000",
                                "#ff0000"
                            ],
                            hoverBackgroundColor: [
                                "#008000",
                                "#ff0000"
                            ]
                        }]
                };
                var myChart = new Chart(ctx, {
                    type: 'pie',
                    data: data,
                    options: {
                        legend: {
                            fullWidth: true,
                            labels: {
                                boxWidth: 10
                            }
                        }
                    },
                    animation: {
                        animateRotate: true}
                });
                myChart.render();
                //      myChart.config.options.defaultFontFamily = 'Courier';
                //      myChart.options.defaultFontFamily = 'Courier';

            }
        }
    });
}
function talkCtrl($scope, $http, $location, $uibModal, $timeout, $route) {
    ctrlInit("Trash Talking", $scope, $location, $route, $timeout);

    $scope.talkNew = talkNew;
    $scope.fdata = talkFriendSave;
    $scope.initEmail = talkFriendSave.userEmail;
    $scope.showInput = false;
    $scope.friendsData = {friend: ""};
    $scope.friendsData.friend = passData.friend;
    $scope.chMax = 200;
    $scope.chCnt = $scope.chMax;
    $scope.commentTxt = "";
    $scope.talkData = "";
    var nowIndex = 0;
    if (passData.friend) {
        $scope.showFriends = true;
    } else {
        $scope.showFriends = false;
    }

    $scope.friendSelect = function () {
        var email = $scope.friendEmail;
        $scope.friendIndex = findEmailIndex(email, passData.friend);
        talkNewCheck(passData.friend[$scope.friendIndex].userEmail);
        $scope.fdata = passData.friend[$scope.friendIndex]
        $scope.fdata.index = $scope.friendIndex;
        talkFriendSave = $scope.fdata;
        getTalkDataCall();
    };

    if ($scope.fdata.userName !== "") {
        talkNewCheck($scope.fdata.userEmail);
        getTalkDataCall();
    }

    // functions
    $scope.talkNewSelect = function () {
        var userEmail = $scope.talkNewEmail;
        $scope.talkNewIndex = findEmailIndex(userEmail, talkNew);
        talkNewUpdate($scope.talkNewIndex);
        var pdIndex = findEmailIndex(userEmail, passData.friend);
        $scope.fdata = passData.friend[pdIndex];
        $scope.fdata.index = pdIndex;
        talkFriendSave = $scope.fdata;
        $route.reload();
    };
    function talkNewCheck(email) {
        for (var i = 0; i < talkNew.length; i++) {
            if (talkNew[i].userEmail === email) {
                talkNewUpdate(i);
                break;
            }
        }
    }
    function talkNewUpdate(index) {
        talkNew.splice(index, 1);
        if (talkNew.length > 0) {
            $scope.showTalkIcon = true;
        } else {
            $scope.showTalkIcon = false;
        }
        $scope.talkNew = talkNew;
    }
    $scope.submit = function () {
        if ($scope.commentTxt === "") {
            return;
        }
        var comment = {
            text: $scope.commentTxt,
            userId: GuserInfo.Id,
            email: GuserInfo.Email,
            name: GuserInfo.Name,
            friendEmail: $scope.fdata.userEmail,
            friendName: $scope.fdata.userName
        };
        var commentStr = JSON.stringify(comment);
        var postData = "{\"talk\":".concat(commentStr).concat("}");
        $http.post(AUSOMESPORTS_API + 'op=sendTalkData', postData)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    if (data.data.status === "success") {
                    } else {
                        $scope.header = "Trash Talk";
                        $scope.message = "Sorry, problem trash talking";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    }
                }, function (data) {
                    $scope.header = "Trash Talk";
                    $scope.message = "Sorry, problem trash talking";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                });
        comment.bubbleme = true;
        comment.time = "now";
        nowIndex++;
//        comment.key = "keyNow" + nowIndex;
        $scope.talkData.push(comment);
        $scope.commentTxt = "";
//        talkDataCache = $scope.talkData;
//        talkFlag = false;
//        $scope.showInput = talkFlag;
//        talkSaveKey = "keyNow" + nowIndex;
//        $timeout(function () {
//            $location.hash(talkSaveKey);
//            $anchorScroll();
//        });
    };
    $scope.chInput = function () {
        $scope.chCnt = $scope.chMax - $scope.commentTxt.length;
    };

    $scope.notiTalkUpdate = function (newData) {
        $scope.fdata = newData;
        if ($scope.fdata.userName !== "") {
            getTalkDataCall();
        }
    }
    function getTalkDataCall() {
        if ($scope.fdata.userEmail) {
//            if (talkFlag) {
//                talkFlag = false;
            $scope.showInput = true;
            $http.get(AUSOMESPORTS_API
                    + "op=getTalkData&userID="
                    + GuserInfo.Id
                    + "&email="
                    + GuserInfo.Email
                    + "&friendEmail="
                    + $scope.fdata.userEmail)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        $scope.talkData = data.data.talkData;
                        $scope.talkData.sort(function (a, b) {
                            if (a.tstamp < b.tstamp) //sort string ascending
                                return -1;
                            if (a.tstamp > b.tstamp)
                                return 1;
                            return 0; //default return value (no sorting)
                        });
                        var i;
                        for (i = 0; i < $scope.talkData.length; i++) {
                            if (!$scope.talkData[i].date) {
                                var d = new Date($scope.talkData[i].tstamp);
                                $scope.talkData[i].date = d.toDateString();
                                var t = d.toTimeString();
                                $scope.talkData[i].time = t.substring(0, 8);
                            }
                            if ($scope.talkData[i].friendId === GuserInfo.Id) {
                                $scope.talkData[i].bubbleme = false;
                            } else {
                                $scope.talkData[i].bubbleme = true;
                            }
//                                $scope.talkData[i].key = "key" + i;
                        }
//                            talkDataCache = $scope.talkData;
//                            talkSaveKey = "key" + (i - 1);
//                            $timeout(function () {
//                                $location.hash(talkSaveKey);
//                                $anchorScroll();
//                            });
                    }, function (data) {
                        $scope.header = "Trash Talk";
                        $scope.message = "Sorry, problem trash talking";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    });
//            } else {
//                $scope.talkData = talkDataCache;
//                $timeout(function () {
//                    $location.hash(talkSaveKey);
//                    $anchorScroll();
//                    talkFlag = true;
//                    $scope.showInput = talkFlag;
//                });
//            }
        }
    }
}
function rankCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    ctrlInit("Rankings", $scope, $location, $route, $timeout);
    $scope.showRank = true;
    if (passData.userInfo.comRank) {
        var dateNow = new Date();
        var timeNow = dateNow.getTime();
        if (timeNow - lastUpdate.rank > updateTimer) {
            lastUpdate.rank = timeNow;
            $http.get(AUSOMESPORTS_API
                    + "op=getRank&userID="
                    + GuserInfo.Id)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        if (data) {
                            rankInfo(data.data);
                            saveRankData = data.data;
                        }
                    }, function (data) {
                        $scope.header = "Rank";
                        $scope.message = "Sorry, problem getting your score and ranking information";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    });
        } else {
            rankInfo(saveRankData);
        }
    } else {
        $scope.showRank = false;
        if (passData.userInfo.username === "none") {
            $scope.msg = "select a username and ";
        } else {
            $scope.msg = "";
        }
    }
    $scope.goToSettings = function () {
        $location.path("/setting");
    };
    function rankInfo(data) {
        $scope.data = data;
        angular.element(document).ready(function () {
            //Angular breaks if this is done earlier than document ready.
            var backgroundColor = [
                'rgba(255, 99, 132, 1)',
                'rgba(54, 162, 235, 1)',
                'rgba(255, 206, 86, 1)',
                'rgba(75, 192, 192, 1)',
                'rgba(153, 102, 255, 1)',
                'rgba(10, 102, 255, 1)',
                'rgba(153, 20, 255, 1)',
                'rgba(153, 102, 30, 1)',
                'rgba(40, 102, 255, 1)',
                'rgba(255, 159, 64, 1)'
            ];
            var borderColor = [
                'rgba(255, 99, 132, 1)',
                'rgba(54, 162, 235, 1)',
                'rgba(255, 206, 86, 1)',
                'rgba(75, 192, 192, 1)',
                'rgba(153, 102, 255, 1)',
                'rgba(10, 102, 255, 1)',
                'rgba(153, 20, 255, 1)',
                'rgba(153, 102, 30, 1)',
                'rgba(40, 102, 255, 1)',
                'rgba(255, 159, 64, 1)'
            ];
            var pickUser = [];
            var pickPer = [];
            for (var i = 0; i < $scope.data.pickRank.length && i < 10; i++) {
                pickUser.push($scope.data.pickRank[i].username);
                pickPer.push($scope.data.pickRank[i].pickPercent);
            }
            var chart = "MyChart-Pick";
            var ctx = document.getElementById(chart);
            var data = {
                labels: pickUser,
                datasets: [
                    {
                        label: "Percentage of right picks",
                        data: pickPer,
                        backgroundColor: backgroundColor,
                        hoverBackgroundColor: backgroundColor,
                        borderColor: borderColor,
                        borderWidth: 1
                    }]
            };
            var pickChart = new Chart(ctx, {
                type: 'horizontalBar',
                data: data,
                options: {
                    scales: {
                        xAxes: [{
                                ticks: {
                                    max: 100,
                                    min: 0
                                }
                            }]
                    }
                },
                animation: {
                    animateScale: true}
            });
            pickChart.render();


            var chaUser = [];
            var chaPer = [];
            for (var i = 0; i < $scope.data.challengeRank.length && i < 10; i++) {
                chaUser.push($scope.data.challengeRank[i].username);
                chaPer.push($scope.data.challengeRank[i].challengePercent);
            }
            chart = "MyChart-Challenge";
            ctx = document.getElementById(chart);
            data = {
                labels: chaUser,
                datasets: [
                    {
                        label: "Percentage of challenges won",
                        data: chaPer,
                        backgroundColor: backgroundColor,
                        hoverBackgroundColor: backgroundColor,
                        borderColor: borderColor,
                        borderWidth: 1
                    }]
            };
            var challengeChart = new Chart(ctx, {
                type: 'horizontalBar',
                data: data,
                options: {
                    scales: {
                        xAxes: [{
                                ticks: {
                                    max: 100,
                                    min: 0
                                }
                            }]
                    }
                },
                animation: {
                    animateScale: true}
            });
            challengeChart.render();
        });

    }
}
function getChallengesCtrl($scope, $http, $routeParams, $location, $uibModal, $route, $timeout) {
    if ($routeParams.mine === "true") {
        ctrlInit("My Challenges", $scope, $location, $route, $timeout);
        $scope.mine = true;
    } else {
        ctrlInit("Challenged", $scope, $location, $route, $timeout);
        $scope.mine = false;
    }
    var tabCnt = 4;
    $scope.anStyle = "nga-default nga-fade";
    $scope.tab = tabInit(tabCnt, lastSetting.challengeTab, "tab");
    $scope.tabClick = function (tabNumber) {
        if (tabNumber > lastSetting.challengeTab) {
            $scope.anStyle = "nga-default nga-slide-left";
        } else {
            $scope.anStyle = "nga-default nga-slide-right";
        }
        lastSetting.challengeTab = tabNumber;
        tabDisplay($scope, tabNumber, "tab");
        if (tabNumber === 1) {
            $scope.wonLostList = $scope.wonList;
        } else if (tabNumber === 2) {
            $scope.wonLostList = $scope.lostList;
        } else if (tabNumber === 3) {
            $scope.wonLostList = $scope.notAcceptedList;
        }
    };
    $scope.nextTab = function () {
        nextTab($scope, lastSetting.challengeTab, tabCnt);
    };
    $scope.prevTab = function () {
        prevTab($scope, lastSetting.challengeTab, tabCnt);
    };
    $scope.activeList = [];
    $scope.notAcceptedList = [];
    $scope.wonList = [];
    $scope.lostList = [];
    $scope.wonLostList = [];
    var dateNow = new Date();
    var timeNow = dateNow.getTime();
    if (timeNow - lastUpdate.challenge > updateTimer) {
        lastUpdate.challenge = timeNow;
        $scope.waitForUpdate = true;
        $http.get(AUSOMESPORTS_API
                + "op=getChallengeUpdates&userID="
                + GuserInfo.Id)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    $scope.waitForUpdate = false;
                    if (data) {
                        passData.challenged = data.data.challenged;
                        passData.myChallenge = data.data.myChallenge;
                    }
                    $scope.activeList = [];
                    $scope.wonList = [];
                    $scope.lostList = [];
                    challengeInfo();
                }, function (data) {
                    $scope.waitForUpdate = false;
                    $scope.header = "Challenge";
                    $scope.message = "Sorry, problem getting your challenge updates";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                    challengeInfo();
                });
    } else {
        $scope.waitForUpdate = false;
        challengeInfo();
    }
    $scope.tabClick(lastSetting.challengeTab);

    // functions section

    function challengeInfo() {
        if ($scope.mine) {
            if (passData.myChallenge)
                for (var i = 0; i < passData.myChallenge.length; i++) {
                    if (passData.friend) {
                        for (var j = 0; j < passData.friend.length; j++) {
                            if (passData.myChallenge[i].opponentEmail === passData.friend[j].userEmail) {
                                passData.myChallenge[i].opponentName = passData.friend[j].userName;
                                break;
                            }
                        }
                    }
                }
            $scope.challenge = passData.myChallenge;
        } else {
            if (passData.challenged && passData.friend)
                for (var i = 0; i < passData.challenged.length; i++) {
                    for (var j = 0; j < passData.friend.length; j++) {
                        if (passData.challenged[i].challengerEmail === passData.friend[j].userEmail) {
                            passData.challenged[i].challengerName = passData.friend[j].userName;
                            break;
                        }
                    }
                }
            $scope.challenge = passData.challenged;
        }
        if ($scope.challenge) {
            if ($scope.activeList.length === 0) {
                for (var i = 0; i < $scope.challenge.length; i++) {
                    if ($scope.challenge[i].result === "tbd" &&
                            $scope.challenge[i].status !== "rejected") {
                        $scope.challenge[i].button = [];
                        var reminder;
                        if ($scope.challenge[i].status === "sent") {
                            $scope.challenge[i].button = true;
                        } else {
                            $scope.challenge[i].button = false;
                        }
                        $scope.activeList.push($scope.challenge[i]);
                    } else {
                        if ($scope.challenge[i].status === "accepted") {
                            if ($scope.mine) {
                                if ($scope.challenge[i].result ===
                                        $scope.challenge[i].myPick) {
                                    $scope.challenge[i].resultMsg =
                                            "Congrats, " + "YOU WON ".italics()
                                            + $scope.challenge[i].prize.bold()
                                            + " from "
                                            + $scope.challenge[i].opponentName.bold();
                                    $scope.challenge[i].resultImg = "img/trophy.png";
                                    $scope.wonList.unshift($scope.challenge[i]);
                                } else {
                                    $scope.challenge[i].resultMsg =
                                            "Sorry, you lost "
                                            + $scope.challenge[i].prize.bold()
                                            + " to "
                                            + $scope.challenge[i].opponentName.bold();
                                    $scope.challenge[i].resultImg = "img/sadFace.png";
                                    $scope.lostList.unshift($scope.challenge[i]);
                                }
                            } else {
                                if ($scope.challenge[i].result ===
                                        $scope.challenge[i].oppPick) {
                                    $scope.challenge[i].resultMsg =
                                            "Congrats, " + "YOU WON ".italics()
                                            + $scope.challenge[i].prize.bold()
                                            + " from "
                                            + $scope.challenge[i].challengerName.bold();
                                    $scope.challenge[i].resultImg = "img/trophy.png";
                                    $scope.wonList.unshift($scope.challenge[i]);
                                } else {
                                    $scope.challenge[i].resultMsg =
                                            "Sorry, you lost "
                                            + $scope.challenge[i].prize.bold()
                                            + " to "
                                            + $scope.challenge[i].challengerName.bold();
                                    $scope.challenge[i].resultImg = "img/sadFace.png";
                                    $scope.lostList.unshift($scope.challenge[i]);
                                }
                            }
                        } else {
                            if ($scope.mine) {
                                $scope.challenge[i].resultMsg =
                                        "Challenge not accepted by "
                                        + $scope.challenge[i].opponentName.bold()
                                        + ". Prize was "
                                        + $scope.challenge[i].prize.bold();
                            } else {
                                $scope.challenge[i].resultMsg =
                                        "I did not accept challenge by  "
                                        + $scope.challenge[i].challengerName.bold()
                                        + ". Prize was "
                                        + $scope.challenge[i].prize.bold();
                            }
                            $scope.challenge[i].resultImg = "img/reject.png";
                            $scope.notAcceptedList.unshift($scope.challenge[i]);
                        }
                    }
                }
            }
        }
    }
    $scope.remind = function (index) {
        var postData = $scope.activeList[index];
        $http.post(AUSOMESPORTS_API + 'op=emailReminder', postData)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    if (data.data.msg === "success") {
                        $scope.waitForUpdate = false;
                        $scope.header = "Challenge Reminder";
                        $scope.message = "Reminder email was sent successfully";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    } else {
                        $scope.header = "Challenge Reminder";
                        $scope.message = data.data.msg;
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    }
                }, function (data) {
                    $scope.header = "Challenge";
                    $scope.message = "Sorry, problem sending challenge to your contact";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                });
    };
    $scope.challengeResponse = function (action, index) {
        var postData = "{\"" + "challengeResponse" + "\":{";
        postData = postData.concat("\"challengerEmail\":\"" +
                $scope.activeList[index].challengerEmail + "\",");
        postData = postData.concat("\"challengerName\":\"" +
                $scope.activeList[index].challengerName + "\",");
        postData = postData.concat("\"challengerID\":\"" +
                $scope.activeList[index].challengerID + "\",");
        postData = postData.concat("\"opponentEmail\":\"" +
                $scope.activeList[index].opponentEmail + "\",");
        postData = postData.concat("\"status\":\"" +
                action + "\",");
        postData = postData.concat("\"userId\":\"" +
                GuserInfo.Id + "\",");
        postData = postData.concat("\"game_id\":\"" +
                $scope.activeList[index].game_id + "\"");
        postData = postData.concat("}}");
        $scope.activeList[index].status = action;
        $scope.activeList[index].button = false;
        $http.post(AUSOMESPORTS_API + 'op=challengeResponse', postData)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
//                    if (data.data.msg === "success") {
//                        $scope.header = "Challenge Response";
//                        $scope.message = "Your response has been sent";
//                        var modalInstance = $uibModal.open({
//                            animation: $scope.animationsEnabled,
//                            templateUrl: 'modalOK.html',
//                            controller: ModalInstanceCtrl,
//                            scope: $scope
//                        });
//                    } else {
//                        $scope.header = "Challenge Response";
//                        $scope.message = data.data.msg;
//                        var modalInstance = $uibModal.open({
//                            animation: $scope.animationsEnabled,
//                            templateUrl: 'modalOK.html',
//                            controller: ModalInstanceCtrl,
//                            scope: $scope
//                        });
//                    }
                }, function (data) {
                    $scope.header = "Challenge Response";
                    $scope.message = "Sorry, could not respond to challenge";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                });
    };
}
function myPicksCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    ctrlInit("My Picks", $scope, $location, $route, $timeout);
    $scope.data = passData;
    $scope.activeList = [];
    $scope.historyList = [];
    $scope.showNoActivePicks = true;
    $scope.showNoHistoryPicks = true;
    $scope.showChallenge = [];
    if (passData.picks) {
        var dateNow = new Date();
        var timeNow = dateNow.getTime();
        if (timeNow - lastUpdate.pick > updateTimer) {
            lastUpdate.pick = timeNow;
            $scope.waitForUpdate = true;
            $http.get(AUSOMESPORTS_API
                    + "op=getPickUpdates&userID="
                    + GuserInfo.Id)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        $scope.waitForUpdate = false;
                        if (data.data.picks) {
                            passData.picks = data.data.picks;
                        }
                        pickInfo();
                    }, function (data) {
                        $scope.waitForUpdate = false;
                        pickInfo();
                        $scope.header = "My Picks";
                        $scope.message = "Sorry, problem getting your pick updates";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    });
        } else {
            $scope.waitForUpdate = false;
            pickInfo();
        }
    } else {
        $scope.waitForUpdate = false;
    }

    function pickInfo() {
        var i;
        var date = todayDate();
        for (i = 0; i < passData.picks.length; i++) {
            if (passData.picks[i].result === "tbd") {
                if (date <= passData.picks[i].date) {
                    $scope.showNoActivePicks = false;
                    $scope.activeList.push(passData.picks[i]);
                    if (passData.picks[i].game_status !== "Scheduled" &&
                            passData.picks[i].game_status !== "Pre-Game" &&
                            passData.picks[i].game_status !== "Warmup" &&
                            passData.picks[i].game_status !== "Preview"
                            ) {
                        $scope.showChallenge[$scope.activeList.length - 1] = false;
                    } else {
                        $scope.showChallenge[$scope.activeList.length - 1] = true;
                    }
                }
            } else {
                $scope.showNoHistoryPicks = false;
                if (passData.picks[i].myPick === passData.picks[i].result) {
                    passData.picks[i].resultMsg =
                            "Congrats";
                    passData.picks[i].resultImg = "img/trophy.png";
                } else {
                    passData.picks[i].resultMsg =
                            "Sorry";
                    passData.picks[i].resultImg = "img/sadFace.png";
                }
                $scope.historyList.unshift(passData.picks[i]);
            }
        }
        $scope.totalItems = $scope.historyList.length;
        $scope.currentPage = 1;
        $scope.itemspp = 20;
        $scope.maxSize = 5;
        if ($scope.totalItems <= $scope.itemspp) {
            $scope.showPages = false;
            setHistoryPage(0, $scope.totalItems);
        } else {
            $scope.showPages = true;
            setHistoryPage(0, $scope.itemspp);
        }

        $scope.setPage = function (pageNo) {
            $scope.currentPage = pageNo;
        };
        $scope.pageChanged = function () {
            //console.log('Page changed to: ' + $scope.currentPage);
            var start = ($scope.currentPage - 1) * $scope.itemspp;
            var end = $scope.currentPage * $scope.itemspp;
            if (end > $scope.totalItems) {
                end = $scope.totalItems;
            }
            setHistoryPage(start, end);
            angular.element(document).ready(function () {
                //Angular breaks if this is done earlier than document ready.
                piePicks(1, $scope.historyPage);
            });
        };
        angular.element(document).ready(function () {
            //Angular breaks if this is done earlier than document ready.
            piePicks(0, $scope.activeList);
            piePicks(1, $scope.historyPage);
        });
    }
    function setHistoryPage(start, end) {
        $scope.historyPage = [];
        for (var j = start; j < end; j++) {
            $scope.historyPage.push($scope.historyList[j]);
        }
    }
    $scope.challenge = function (game_id) {
        var index = findChallenge(game_id);
        if (index !== -1) {
            $location.path("/challenge/" + index);
        } else {
            $scope.header = "Challenge";
            $scope.message = 'You must pick a winner first before challenging';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            modalInstance.result.then(function () {
                //console.log("Modal Closed!!!");
            }, function () {
                //console.log("Modal Dismissed!!!");
            });
        }
    };
    function piePicks(type, eachList) {
        for (var j = 0; j < eachList.length; j++) {
            var myCnt, oppCnt;
            if (eachList[j].myPickLocation === "home") {
                myCnt = eachList[j].homeCnt;
                oppCnt = eachList[j].visitorCnt;
            } else {
                oppCnt = eachList[j].homeCnt;
                myCnt = eachList[j].visitorCnt;
            }
            var chart = "MyChart-";
            chart = chart.concat(type + "-" + (j));
            var ctx = document.getElementById(chart);
            var data = {
                labels: [
                    eachList[j].myPick,
                    eachList[j].oppPick
                ],
                datasets: [
                    {
                        data: [myCnt, oppCnt],
                        backgroundColor: [
                            "#008000",
                            "#ff0000"
                        ],
                        hoverBackgroundColor: [
                            "#008000",
                            "#ff0000"
                        ]
                    }]
            };
            var myChart = new Chart(ctx, {
                type: 'pie',
                data: data,
                options: {
                    legend: {
                        display: false
                    }
                },
                animation: {
                    animateRotate: true}
            });
        }
    }

    var tabCnt = 2;
    $scope.tab = tabInit(tabCnt, lastSetting.myPicksTab, "tab");
    $scope.tabClick = function (tabNumber) {
        lastSetting.myPicksTab = tabNumber;
        tabDisplay($scope, tabNumber, "tab");
    };
    $scope.nextTab = function () {
        nextTab($scope, lastSetting.myPicksTab, tabCnt);
    };
    $scope.prevTab = function () {
        prevTab($scope, lastSetting.myPicksTab, tabCnt);
    };
}
function getGamesCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    ctrlInit("Pick Winners", $scope, $location, $route, $timeout);
    $scope.home = "home";
    $scope.away = "away";
    $scope.dateFormatted;
    $scope.waitForUpdate = false;
    $scope.showstatus = false;
    $scope.data = passData;
    $scope.snum = 0;
    $scope.sportSelect = lastSched.sport;
    $scope.teamSelect = lastSched.team;
    $scope.tab = tabInit(2, lastSetting.getGamesTab, "tab");
    $scope.tabClick = function (tabNumber) {
        lastSetting.getGamesTab = tabNumber;
        tabDisplay($scope, tabNumber, "tab");
        if (tabNumber === 0) {
            $scope.gotDate();
        } else if (tabNumber === 1) {
            $scope.gotTeam();
        }
    };
    $scope.swipeAction = function (num) {
        if (lastSetting.getGamesTab === 0) {
            $scope.dateChange(num);
        }
    };
    if (gdd === null) {
        todayGames();
    } else if (refreshGames) {
        callGamesAPI(gameDay);
        refreshGames = false;
    } else {
        //  var res = gdd.date.split("-");
        var res = gameDay.split("-");
        var d = new Date(res[0], res[1] - 1, res[2]);
        $scope.dateFormatted = d.toDateString();
        if (gdd.sport) {
            var dateNow = new Date();
            var timeNow = dateNow.getTime();
            if (((todayDate() === gameDay) &&
                    (timeNow - lastUpdate.getGames > updateTimer)) ||
                    (timeNow - lastUpdate.getGames > updateTimerLong)) {
                lastUpdate.getGames = timeNow;
                callGamesAPI(gameDay);
                return;
            }
            for (var L = 0; L < gdd.sport.length; L++) {
                var prefIndex = -1;
                if (passData.prefTeams) {
                    for (var k = 0; k < passData.prefTeams.sports.length; k++) {
                        if (passData.prefTeams.sports[k].sport === gdd.sport[L].name) {
                            prefIndex = k;
                            break;
                        }
                    }
                }
                if (gdd.sport[L].game) {
                    var game = [];
                    var pref = false;
                    for (var i = 0; i < gdd.sport[L].game.length; i++) {
                        gdd.sport[L].game[i].away_pick_icon = "img/checkmark.png";
                        gdd.sport[L].game[i].home_pick_icon = "img/blank.png";
                        gdd.sport[L].game[i].snum = L;
                        if (gdd.sport[L].game[i].status === "Scheduled" ||
                                gdd.sport[L].game[i].status === "Pre-Game" ||
                                gdd.sport[L].game[i].status === "Warmup" ||
                                gdd.sport[L].game[i].status === "Preview" ||
                                debugging) {
                            gdd.sport[L].game[i].pickButton = true;
                            gdd.sport[L].game[i].cButton = true;
                            gdd.sport[L].game[i].home_pick_icon = "img/whichTeam.png";
                            gdd.sport[L].game[i].away_pick_icon = "img/whichTeam.png";
                            if (passData.picks) {
                                for (var j = 0; j < passData.picks.length; j++) {
                                    //                                   if (passData.picks[j].date === gdd.date) {
                                    if (passData.picks[j].date === gdd.sport[L].game[i].date) {
                                        if (passData.picks[j].game_id === gdd.sport[L].game[i].game_id) {
                                            if (passData.picks[j].myPick === gdd.sport[L].game[i].home_name_abbrev) {
                                                gdd.sport[L].game[i].home_pick_icon = "img/pickTeam.png";
                                                gdd.sport[L].game[i].away_pick_icon = "img/blank.png";
                                            } else {
                                                gdd.sport[L].game[i].away_pick_icon = "img/pickTeam.png";
                                                gdd.sport[L].game[i].home_pick_icon = "img/blank.png";
                                            }
                                        }
                                    }
                                }

                            }
                        } else {
                            gdd.sport[L].game[i].pickButton = false;
                            gdd.sport[L].game[i].cButton = false;
                            if (passData.picks) {
                                for (var m = 0; m < passData.picks.length; m++) {
                                    if (passData.picks[m].game_id === gdd.sport[L].game[i].game_id) {
                                        if (passData.picks[m].myPick === gdd.sport[L].game[i].home_name_abbrev) {
                                            gdd.sport[L].game[i].home_pick_icon = "img/checkmark.png";
                                            gdd.sport[L].game[i].away_pick_icon = "img/blank.png";
                                        } else {
                                            gdd.sport[L].game[i].away_pick_icon = "img/checkmark.png";
                                            gdd.sport[L].game[i].home_pick_icon = "img/blank.png";
                                        }
                                        gdd.sport[L].game[i].pickButton = true;
                                        break;
                                    }
                                }
                            }
                        }
                        if (prefIndex > -1) {
                            if (passData.prefTeams.sports[prefIndex].teams) {
                                if (passData.prefTeams.sports[prefIndex].teams.length > 2) {
                                    pref = true;
                                    if ((passData.prefTeams.sports[prefIndex].teams.indexOf(gdd.sport[L].game[i].home_name_abbrev) > -1) ||
                                            (passData.prefTeams.sports[prefIndex].teams.indexOf(gdd.sport[L].game[i].away_name_abbrev) > -1)) {
                                        game.push(gdd.sport[L].game[i]);
                                    }
                                }
                            }
                        }
                    }
                    if (pref) {
                        gdd.sport[L].game = game;
                    }
                } else if (gdd.status) {
                    $scope.showstatus = true;
                }
            }
        }
    }
    $scope.gdd = gdd;
    function todayGames() {
        gameDay = todayDate();
        callGamesAPI(gameDay);
    }

    function callGamesAPI(date) {
        var url = AUSOMESPORTS_API.concat("op=getGames&sport=" + passData.prefSports + "&date=");
        url = url.concat(date);
        $scope.waitTopic = date;
        $scope.waitForUpdate = true;
        $http.get(url)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    gdd = data.data;
                    $location.path("/refreshGames");
                }, function (data) {
                });
    }
    $scope.selectImage = function (snum, index, game_id, myPick, oppPick, myPickLocation) {
        if (gdd.sport[snum].game[index].status !== "Scheduled" &&
                gdd.sport[snum].game[index].status !== "Pre-Game" &&
                gdd.sport[snum].game[index].status !== "Warmup" &&
                gdd.sport[snum].game[index].status !== "Preview" &&
                !debugging) {
            $scope.header = "Picks";
            $scope.message = "Sorry, too late to make a pick for this game";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
        var addPick = true;
        if (passData.picks) {
            for (var i = 0; i < passData.picks.length; i++) {
                if (passData.picks[i].game_id === game_id) {
                    addPick = false;
                    break;
                }
            }
        } else {
            passData.picks = [];
        }
        if (addPick) {
            var myPickURL;
            var oppPickURL;
            if (myPickLocation === "home") {
                myPickURL = gdd.sport[snum].game[index].home_logo_url;
                oppPickURL = gdd.sport[snum].game[index].away_logo_url;
            } else {
                oppPickURL = gdd.sport[snum].game[index].home_logo_url;
                myPickURL = gdd.sport[snum].game[index].away_logo_url;
            }
            var pick = {
                userID: GuserInfo.Id,
                sport: gdd.sport[snum].name,
                sportUrl: gdd.sport[snum].sportUrl,
                date: gdd.sport[snum].game[index].date,
                game_id: game_id,
                result: "tbd",
                game_status: gdd.sport[snum].game[index].status,
                myPickURL: myPickURL,
                myPick: myPick,
                myPickLocation: myPickLocation,
                oppPickURL: oppPickURL,
                oppPick: oppPick};
            var pickStr = JSON.stringify(pick);
            passData.picks.push(pick);
            if (myPick === gdd.sport[snum].game[index].home_name_abbrev) {
                gdd.sport[snum].game[index].home_pick_icon = "img/pickTeam.png";
                gdd.sport[snum].game[index].away_pick_icon = "img/blank.png";
            } else {
                gdd.sport[snum].game[index].away_pick_icon = "img/pickTeam.png";
                gdd.sport[snum].game[index].home_pick_icon = "img/blank.png";
            }
            var postData = "{\"addPick\":";
            postData = postData.concat(pickStr);
            postData = postData.concat("}");
            $http.post(AUSOMESPORTS_API + 'op=addPick', postData)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        lastUpdate.pick = 0;
                        //console.log("success goes here");
                    }, function (data) {
                        //console.log("error goes here");
                        //console.log(data);
                    });
            adCnt.pick++;
            if (adCnt.pick % passData.pickTriggerAd === 0) {
                $scope.sport = gdd.sport[snum].name;
                $scope.team = myPick;
                $scope.header = "Hello sports fan.";
                $scope.message = "You may like these.";
                var modalInstance = $uibModal.open({
                    animation: $scope.animationsEnabled,
                    templateUrl: 'ads.html',
                    controller: adsCtrl,
                    scope: $scope
                });
            }
            //console.log("Game ID:" + game_id + " myPick:" + myPick + " oppPick" + oppPick);
        } else {
            $scope.header = "Picks";
            $scope.message = "You have already made a pick";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
        }
    };
    $scope.challenge = function (game_id) {
        var index = findChallenge(game_id);
        if (index !== -1) {
            $location.path("/challenge/" + index);
        } else {
            $scope.header = "Challenge";
            $scope.message = 'You must pick a winner first before challenging';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            modalInstance.result.then(function (data) {
                //console.log("Modal Closed with " + data);
            }, function (data) {
                //console.log("Modal Dismissed with " + data);
            });
        }
    };
    $scope.gotSport = function () {
        $scope.snum = 0;
        lastSched.sport = $scope.sport;
        for (var i = 0; i < passData.sports.length; i++) {
            if ($scope.sport === passData.sports[i].sport) {
                $scope.snum = i;
                break;
            }
        }
        $scope.team = "";
    };
    $scope.sport = lastSched.sport;
    $scope.gotSport();
    $scope.team = lastSched.team;
    $scope.gotTeam = function () {
        if ($scope.team === "") {
            gdd = "";
            $location.path("/refreshGames");
            return;
        }
        lastSched.team = $scope.team;
        if ($scope.team !== null) {
            lastSched.team = $scope.team;
            var url = AUSOMESPORTS_API.concat("op=getTeamGames&sport="
                    + $scope.sport
                    + "&team="
                    + $scope.team);
            $scope.waitTopic = $scope.team + " in " + $scope.sport;
            $scope.waitForUpdate = true;
            $http.get(url)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        gdd = data.data;
                        $location.path("/refreshGames");
                    }, function (data) {
                    });
        }
    };
    $scope.dateChange = function (num) {
        var dateParts = gameDay.split("-");
        var result = new Date(dateParts[0], dateParts[1] - 1, dateParts[2]);
        var newDate = result.getDate() + num;
        result.setDate(newDate);
        dtSave = result;
        dateToString(result);
        callGamesAPI(gameDay);
    };
    // date picker code start

    $scope.today = function () {
        $scope.dt = new Date();
        dateToString($scope.dt);
        callGamesAPI(gameDay);
    };
    if (dtSave === null) {
        $scope.dt = new Date();
        dtSave = $scope.dt;
    } else {
        $scope.dt = dtSave;
    }

    $scope.clear = function () {
        $scope.dt = null;
    };
    $scope.inlineOptions = {
        customClass: getDayClass,
        minDate: new Date(),
        showWeeks: true
    };
    $scope.dateOptions = {
        showWeeks: false,
        formatYear: 'yy',
        maxDate: new Date(2020, 5, 22),
        minDate: new Date(),
        startingDay: 1
    };
    $scope.toggleMin = function () {
        $scope.inlineOptions.minDate = $scope.inlineOptions.minDate ? null : new Date();
        $scope.dateOptions.minDate = $scope.inlineOptions.minDate;
    };
    $scope.toggleMin();
    $scope.open1 = function () {
        $scope.popup1.opened = true;
    };
    $scope.setDate = function (year, month, day) {
        $scope.dt = new Date(year, month, day);
    };
    $scope.gotDate = function () {
        dtSave = $scope.dt;
        dateToString($scope.dt);
        callGamesAPI(gameDay);
    };
    function dateToString(dateObj) {
        var yr = (dateObj.getFullYear()).toString();
        var moNum = (dateObj.getMonth()) + 1;
        var mo = moNum.toString();
        if (moNum < 10) {
            mo = "0".concat(mo);
        }
        var daNum = (dateObj.getDate());
        var da = daNum.toString();
        if (daNum < 10) {
            da = "0".concat(da);
        }
        gameDay = yr.concat("-").concat(mo).concat("-").concat(da);
    }
    $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
    $scope.format = $scope.formats[0];
    $scope.altInputFormats = ['M!/d!/yyyy'];
    $scope.popup1 = {
        opened: false
    };
    var tomorrow = new Date();
    tomorrow.setDate(tomorrow.getDate() + 1);
    var afterTomorrow = new Date();
    afterTomorrow.setDate(tomorrow.getDate() + 1);
    $scope.events = [
        {
            date: tomorrow,
            status: 'full'
        },
        {
            date: afterTomorrow,
            status: 'partially'
        }
    ];
    function getDayClass(data) {
        var date = data.date,
                mode = data.mode;
        if (mode === 'day') {
            var dayToCheck = new Date(date).setHours(0, 0, 0, 0);
            for (var i = 0; i < $scope.events.length; i++) {
                var currentDay = new Date($scope.events[i].date).setHours(0, 0, 0, 0);
                if (dayToCheck === currentDay) {
                    return $scope.events[i].status;
                }
            }
        }
        return '';
    }
// date picker code end
}

function refreshGamesCtrl($location) {
    $location.path("/getGames");
}
function challengeCtrl($scope, $cordovaOauth, $http, $routeParams, $location, $uibModal, $route, $timeout) {
    ctrlInit("Challenge", $scope, $location, $route, $timeout);
    $scope.friendsData = "";
    var picksIndex = $routeParams.index;
    $scope.pick = passData.picks[picksIndex];
    currentPickIndex = picksIndex;
    $scope.names = [];
    $scope.emails = [];
    $scope.prize = [];
    $scope.prize2 = [];
    $scope.prizeItem = "";
    $scope.waitForChallenge = false;
    $scope.prizeChMax = 20;
    $scope.prizeChCnt = [];
    $scope.fchaSent = [];
    $scope.gchaSent = [];
    $scope.sendAnother = false;
    if (prize_array.length === 0) {
        var url = AUSOMESPORTS_API.concat("op=getPrizeArray");
        $http.get(url)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    if (data) {
                        prize_array = data.data.prizeArray;
                        $scope.prize_array = prize_array;
                    }
                }, function (data) {
                    prize_array = [
                        "bragging rights",
                        "dinner",
                        "lunch",
                        "breakfast",
                        "ice cream",
                        "cookie",
                        "other"];
                    $scope.prize_array = prize_array;
                });
    } else {

        $scope.prize_array = prize_array;
    }
    var tabCnt = 3;
    var lastTab = 0;
    $scope.tab = tabInit(tabCnt, 0, "tab");
    var SCOPES = ["https://www.googleapis.com/auth/contacts.readonly https://www.googleapis.com/auth/user.emails.read"];
    friendsList(true);
    var res = $scope.pick.date.split("-");
    var d = new Date(res[0], res[1] - 1, res[2]);
    $scope.dateFormatted = d.toDateString();

    // --functions--
    $scope.tabClick = function (tabNumber) {
        lastTab = tabNumber;
        $scope.prizeChCnt = [];
        tabDisplay($scope, tabNumber, "tab");
        if (tabNumber === 1) {
            friendsList(false);
        }
        if (tabNumber === 2) {
            checkAuth();
        }
    };
    $scope.nextTab = function () {
        nextTab($scope, lastTab, tabCnt);
    };
    $scope.prevTab = function () {
        prevTab($scope, lastTab, tabCnt);
    };
    function friendsList(firstTime) {
        var url = AUSOMESPORTS_API.concat("op=getFriends&userID=");
        url = url.concat(GuserInfo.Id);
        $http.get(url)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    $scope.friendsData = data.data;
                    passData.friend = data.data.friend;
                    if (firstTime) {
                        if (data.data.friend) {
                            for (var i = 0; i < data.data.friend.length; i++) {
                                $scope.fchaSent.push(false);
                            }
                            //                       $scope.tabClick(1);
                            $scope.tab = tabInit(tabCnt, 1, "tab");
                            lastTab = 1;
                        } else {
                            $scope.tab = tabInit(tabCnt, 0, "tab");
                        }
                    }
                }, function (data) {
                    if (firstTime) {
                        $scope.tab = tabInit(tabCnt, 0, "tab");
                    }
                    //console.log("no friends found");
                });
    }
    $scope.challengeFriend = function (index) {
        if (!$scope.prize[index]) {
            $scope.header = "Challenge Friend";
            $scope.message = 'Please specify what the winner gets';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
        var userName = $scope.friendsData.friend[index].userName;
        $scope.fchaSent[index] = true;
        postChallenge($scope.prize[index], $scope.friendsData.friend[index].userName,
                $scope.friendsData.friend[index].userEmail, "sent");
    };
    $scope.contactInvite = function (index) {
        if ($scope.prize2[index] === "") {
            $scope.header = "Challenge Friend";
            $scope.message = 'Please specify what the winner gets';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
        $scope.gchaSent[index] = true;
        var status = postInvite($scope.prize2[index], $scope.names[index], $scope.emails[index]);
    };
    $scope.emailChallenge = function () {
        var name = this.name;
        var email = this.email;
        var eprize = this.eprize;
        if (!name || !email || !eprize) {
            $scope.header = "Challenge Friend";
            $scope.message = 'Please provide name, email, and prize for winner';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
        this.name = "";
        this.email = "";
        $scope.sendAnother = true;
        var status = postInvite(eprize, name, email);
    };
    $scope.chInput = function (index, inputStr) {
        $scope.prizeChCnt[index] = inputStr.length + " of ";
    };
    function postInvite(eprize, name, email) {
        email = email.toLowerCase();
        if ($scope.friendsData !== "") {
            email = email.replace(/\s+/g, '');
            for (var i = 0; i < $scope.friendsData.friend.length; i++) {
                if ($scope.friendsData.friend[i].userEmail === email) {
                    if ($scope.friendsData.friend[i].userName !== name) {
                        $scope.friendsData.friend[i].userName = name;
                        passData.friend = $scope.friendsData.friend;
                        $http.get(AUSOMESPORTS_API
                                + "op=updateFriendName&userID="
                                + GuserInfo.Id
                                + "&email="
                                + email
                                + "&username="
                                + name)
                                .then(function (data) {
                                }, function (data) {
                                });
                    }
                    postChallenge(eprize, name, email, "sent");
                    return;
                }
            }
        }
        if (ValidateEmail(email)) {
            $scope.waitForChallenge = true;
            var postData = "{\"invite\":{";
            postData = postData.concat("\"userID\":\"" + GuserInfo.Id + "\",");
            postData = postData.concat("\"userName\":\"" + GuserInfo.Name + "\",");
            postData = postData.concat("\"userEmail\":\"" + GuserInfo.Email + "\",");
            postData = postData.concat("\"name\":\"" + name + "\",");
            postData = postData.concat("\"status\":\"" + "pending" + "\",");
            postData = postData.concat("\"email\":\"" + email + "\"");
            postData = postData.concat("}}");
            $http.post(AUSOMESPORTS_API + 'op=invite', postData)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        if (data.data.status === "success") {
                            postChallenge(eprize, name, email, "pending");
                            return;
                        }
                        postChallenge(eprize, name, email, "sent");
                        return;
                    }, function (data) {
                        $scope.waitForChallenge = false;
                        //console.log("invite error goes here");
                        $scope.header = "Friend Invited";
                        $scope.message = "Sorry, problem sending invitation to your contact";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                        return;
                    });
        } else {
            $scope.header = "Challenge";
            $scope.message = 'Bad email format; example format abc@xyz.com';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
    }

    function postChallenge(prize, name, email, status) {
        $scope.waitForChallenge = true;
        var postData = "{\"challenge\":";
        var challenge = {status: status,
            challengerID: GuserInfo.Id,
            challengerName: GuserInfo.Name,
            challengerEmail: GuserInfo.Email,
            opponentID: "tbd",
            opponentName: name,
            opponentEmail: email,
            game_id: passData.picks[currentPickIndex].game_id,
            sport: passData.picks[currentPickIndex].sport,
            sportUrl: passData.picks[currentPickIndex].sportUrl,
            myPick: passData.picks[currentPickIndex].myPick,
            oppPick: passData.picks[currentPickIndex].oppPick,
            myPickURL: passData.picks[currentPickIndex].myPickURL,
            oppPickURL: passData.picks[currentPickIndex].oppPickURL,
            myPickLocation: passData.picks[currentPickIndex].myPickLocation,
            date: passData.picks[currentPickIndex].date,
            game_status: "tbd",
            challengeSeen: "no",
            responseSeen: "no",
            result: "tbd",
            prize: prize};
        var challengeStr = JSON.stringify(challenge);
        postData = postData.concat(challengeStr);
        postData = postData.concat("}");
        $http.post(AUSOMESPORTS_API + 'op=challenge', postData)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    $scope.waitForChallenge = false;
                    if (data.data.msg === "duplicate") {
                        var msg = ("There is already a challenge for this game between you and\n\n " + name);
                        $scope.header = "Challenge";
                        $scope.message = msg;
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    } else {
                        lastUpdate.challenge = 0;
                        adCnt.cha++;
                        var msg = ("A challenge has been sent to\n\n" + name +
                                " at " + email +
                                "  \n\n" + "You picked\n" +
                                passData.picks[currentPickIndex].myPick + " to beat " +
                                passData.picks[currentPickIndex].oppPick +
                                " \n\nChallenge winner gets:\n" +
                                prize);
                        $scope.header = "Challenge";
                        $scope.message = msg;
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    }
                }, function (data) {
                    $scope.waitForChallenge = false;
                    $scope.header = "Challenge";
                    $scope.message = "Sorry, problem sending challenge to your contact";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                });
    }
    function checkAuth() {
        if (onDevice) {
            if (access_token === null) {
                $cordovaOauth.google(CLIENT_ID, ["email", "profile", "https://www.googleapis.com/auth/contacts.readonly"])
                        .then(function (result) {
                            // id_token = result.id_token;
                            access_token = result.access_token;
                            //  alert("cordova auth success: " + JSON.stringify(result));
                            loadPeopleApi();
                        }, function (error) {
                            $scope.header = "Google Contacts";
                            $scope.message = "Sorry, there was a problem getting contacts, please try again";
                            var modalInstance = $uibModal.open({
                                animation: $scope.animationsEnabled,
                                templateUrl: 'modalOK.html',
                                controller: ModalInstanceCtrl,
                                scope: $scope
                            });
                        });
            } else {
                loadPeopleApi();
            }

        } else {
            if (access_token === null) {
                gapi.load('auth2', function () {
                    gapi.auth2.authorize(
                            {
                                'client_id': CLIENT_ID,
                                'scope': SCOPES.join(' '),
                                'immediate': true
                            }, handleAuthResult);
                });
            } else {
                loadPeopleApi();
            }
        }
    }
    function handleAuthResult(authResult) {
        var authorizeDiv = document.getElementById('authorize-div');
        if (authResult && !authResult.error) {
            // Hide auth UI, then load client library.
            access_token = authResult.access_token;
            authorizeDiv.style.display = 'none';
            loadPeopleApi();
        } else {
            authorizeDiv.style.display = 'inline';
        }
    }
    $scope.handleAuthClick = function (event) {
        //     function handleAuthClick(event) {
        gapi.auth2.authorize(
                {client_id: CLIENT_ID, scope: SCOPES, immediate: false},
                handleAuthResult);
        return false;
    };
    function loadPeopleApi() {
        //    gapi.client.load('https://people.googleapis.com/$discovery/rest', 'v1', listConnectionNames);

        // alert("do loadPeopleApi");
        $http.get("https://people.googleapis.com/v1/people/me/connections",
                {params: {access_token: access_token,
                                    personFields: 'names,emailAddresses'}})
                .then(function (res) {
                    //   alert("loadPeopleApi success: " + JSON.stringify(res));
                    listConnectionNames(res);
                }, function (error) {
                    //  alert("loadPeopleApi Error: " + JSON.stringify(error));
                    access_token = null;
                    checkAuth();
                });

    }
    function listConnectionNames(res) {

        if (res.data.connections) {
            var resourceNames = "resourceNames=" + res.data.connections[0].resourceName;
            for (var i = 1; i < res.data.connections.length && i < 50; i++) {
                resourceNames = resourceNames + "&resourceNames=" + res.data.connections[i].resourceName;
            }
            //   alert("listConnectionNames, doing batchGet");
            $http.get("https://people.googleapis.com/v1/people:batchGet?" + resourceNames,
                    {params: {access_token: access_token,
                                    personFields: 'names,emailAddresses'}})
                    .then(function (data) {
                        //     alert("contact data: " + JSON.stringify(data));
                        for (var j = 0; j < data.data.responses.length; j++) {
                            $scope.names[j] = data.data.responses[j].person.names[0].displayName;
                            $scope.emails[j] = data.data.responses[j].person.emailAddresses[0].value;
                            $scope.prize2[j] = "";
                            $scope.gchaSent.push(false);
                        }
                    }, function (error) {
                        $scope.header = "Google Contacts";
                        $scope.message = "Sorry, there was a problem getting contacts, please try again";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                        access_token = null;
                        checkAuth();
                    });
        }
    }
}

function filterCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    $scope.viewClass = 'animate-home';
    ctrlInit("Filter", $scope, $location, $route, $timeout);
    var sportIndex;
    var tabCnt = 2;
    $scope.data = passData;
    $scope.tab = tabInit(tabCnt, lastSetting.filterTab, "tab");
    $scope.tabClick = function (tabNumber) {
        lastSetting.filterTab = tabNumber;
        tabDisplay($scope, tabNumber, "tab");
    };
    $scope.nextTab = function () {
        nextTab($scope, lastSetting.filterTab, tabCnt);
    };
    $scope.prevTab = function () {
        prevTab($scope, lastSetting.filterTab, tabCnt);
    };
//    $scope.tabClick(lastSetting.filterTab);
    $scope.sportTab = tabInit(passData.sports.length, lastSetting.sportTab, "sport");
    $scope.sportTabClick = function (tabNumber) {
        lastSetting.sportTab = tabNumber;
        sportTabDisplay($scope, tabNumber, "sport");
        sportIndex = tabNumber;
    };
//    $scope.sportTabClick(lastSetting.sportTab);
    $scope.checked = [];
    $scope.teamChecked = [[]];
    $scope.selection = [];
    $scope.teamSelection = [[]];
    // sports
    if (passData.prefSports) {
        $scope.selection = (passData.prefSports).toString().split('-');
        if ($scope.selection === null) {
            $scope.selection[0] = passData.prefSports;
        }
    } else {
        for (var i = 0; i < passData.sports.length; i++) {
            $scope.selection.push(passData.sports[i].sport);
        }
    }
    for (var i = 0; i < passData.sports.length; i++) {
        $scope.checked[i] = false;
        $scope.teamChecked[i] = [];
        for (var j = 0; j < $scope.selection.length; j++) {
            if (passData.sports[i].sport === $scope.selection[j]) {
                $scope.checked[i] = true;
                break;
            }
        }
    }

// teams selection array
    if (!passData.prefTeams) {
        passData.prefTeams = {
            sports: []
        };
    }
    for (var i = 0; i < passData.sports.length; i++) {
        if (!passData.prefTeams.sports[i]) {
            passData.prefTeams.sports[i] = {
                sport: passData.sports[i].sport,
                teams: ""
            };
        }
        if (!$scope.teamSelection[i]) {
            $scope.teamSelection[i] = [];
        }
        var idx = -1;
        for (var j = 0; j < passData.prefTeams.sports.length; j++) {
            if (passData.prefTeams.sports[j].sport === passData.sports[i].sport) {
                idx = j;
                break;
            }
        }
        if (idx >= 0) {
            if (passData.prefTeams.sports[i].teams) {
                if (idx !== i) {
                    var temp = passData.prefTeams.sports[i].teams;
                    passData.prefTeams.sports[i].teams = passData.prefTeams.sports[idx].teams;
                    passData.prefTeams.sports[idx].teams = temp;
                }
                var teams = (passData.prefTeams.sports[i].teams).toString().split('-');
                $scope.teamSelection[i] = teams;
            } else {
                $scope.teamSelection[i] = [];
            }
        } else {
            for (var j = 0; j < passData.sports[i].teams.length; j++) {
                $scope.teamSelection[i].push(passData.sports[i].teams[j].team);
                $scope.teamChecked[i][j] = true;
            }
        }
    }

// set team check marks
    for (var i = 0; i < passData.sports.length; i++) {
        for (var j = 0; j < passData.sports[i].teams.length; j++) {
            $scope.teamChecked[i][j] = false;
            if ($scope.teamSelection[i].indexOf(passData.sports[i].teams[j].team) > -1) {
                $scope.teamChecked[i][j] = true;
                //  console.log("checked team " + passData.sports[i].teams[j].team);
            }
        }
    }

// toggle selection for sport
    $scope.sportSelection = function (sport, index) {
        var idx = $scope.selection.indexOf(sport);
        if ((idx > -1) && ($scope.selection.length === 1)) {
            $scope.checked[index] = true;
            $scope.header = "Sport Preferences";
            $scope.message = "Sorry, you must choose at least 1 sport";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
// is currently selected
        if (idx > -1) {
            $scope.selection.splice(idx, 1);
        }
// is newly selected
        else {
            $scope.selection.push(sport);
        }
        refreshGames = true;
        var sportsStr = $scope.selection[0];
        for (var i = 1; i < $scope.selection.length; i++) {
            sportsStr = sportsStr.concat("-").concat($scope.selection[i]);
        }
        passData.prefSports = sportsStr;
        var sportsObj = {
            userID: GuserInfo.Id,
            prefSports: sportsStr,
            type: "prefSports"};
        var sportJSON = JSON.stringify(sportsObj);
        prefAPIcall(sportJSON);
    };
    // toggle selection for team
    $scope.teamSelect = function (team, tIndex, sport, sIndex) {
        var idx = $scope.teamSelection[sIndex].indexOf(team);
        // is currently selected
        if (idx > -1) {
            $scope.teamSelection[sIndex].splice(idx, 1);
        }
        // is newly selected
        else {
            $scope.teamSelection[sIndex].push(team);
        }
        var teamsJSON = prepPrefTeamsAPI(sIndex);
        prefAPIcall(teamsJSON);
    };
    $scope.selectAll = function (sIndex) {
        $scope.teamSelection[sIndex] = [];
        for (var j = 0; j < passData.sports[sIndex].teams.length; j++) {
            $scope.teamSelection[sIndex].push(passData.sports[sIndex].teams[j].team);
            $scope.teamChecked[sIndex][j] = true;
        }
        var teamsJSON = prepPrefTeamsAPI(sIndex);
        prefAPIcall(teamsJSON);
    };
    $scope.selectNone = function (sIndex) {
        $scope.teamSelection[sIndex] = [];
        for (var j = 0; j < passData.sports[sIndex].teams.length; j++) {
            $scope.teamChecked[sIndex][j] = false;
        }
        var teamsJSON = prepPrefTeamsAPI(sIndex);
        prefAPIcall(teamsJSON);
    };
    function prepPrefTeamsAPI(sIndex) {

        refreshGames = true;
        var teamsStr = $scope.teamSelection[sIndex][0];
        for (var i = 1; i < $scope.teamSelection[sIndex].length; i++) {
            teamsStr = teamsStr.concat("-").concat($scope.teamSelection[sIndex][i]);
        }
        passData.prefTeams.sports[sIndex].teams = teamsStr;
        var sportsArray = [{}];
        for (var i = 0; i < passData.sports.length; i++) {
            var sportsObj = {
                sport: passData.sports[i].sport,
                teams: passData.prefTeams.sports[i].teams
            };
            sportsArray[i] = sportsObj;
        }
        var obj = {sports: sportsArray};
        var teamsObj = {
            userID: GuserInfo.Id,
            prefTeams: obj,
            type: "prefTeams"};
        var teamsJSON = JSON.stringify(teamsObj);
        return teamsJSON;
    }
    function prefAPIcall(data) {
        $http.post(AUSOMESPORTS_API + 'op=pref', data)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                }, function (data) {
                    //console.log(data);
                });
    }
}

function settingCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    ctrlInit("Settings", $scope, $location, $route, $timeout);
    $scope.appVersion = appVersion;
    $scope.chMax = 10;
    $scope.chCnt = $scope.chMax;
    if (passData.userInfo.username === "none") {
        $scope.showUsername = false;
    } else {
        $scope.showUsername = true;
        $scope.username = passData.userInfo.username;
    }
    $scope.emailSet = [
        {desc: "When someone challenges me",
            id: "emChaMe",
            state: passData.userInfo.emChaMe},
        {desc: "Daily summary of my pick results",
            id: "emPickSum",
            state: passData.userInfo.emPickSum},
        {desc: "Daily summary of my challenge results",
            id: "emChaSum",
            state: passData.userInfo.emChaSum}];
    $scope.comSet = [
        {desc: "See my ranking against other players",
            id: "comRank",
            state: passData.userInfo.comRank}
        //   {desc: "Allow challenges from any player",
        //       id: "comChaAll",
        //       state: passData.userInfo.comChaAll}
    ];
    $scope.emailItemSel = function (index) {
        //console.log("in email select");
    };
    $scope.comItemSel = function (index) {
        if (!$scope.showUsername) {
            $scope.comSet[index].state = false;
            $scope.header = "Community settings";
            $scope.message = "You must choose a user name first";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
        }
    };
    $scope.checkUsername = function () {
        if ($scope.username) {
            //console.log("check user name " + $scope.username);
            $http.get(AUSOMESPORTS_API
                    + "op=username&userID="
                    + GuserInfo.Id
                    + "&username="
                    + $scope.username)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                            return;
                        }
                        if (data) {
                            if (data.data.status === "success") {
                                $scope.showUsername = true;
                                passData.userInfo.username = $scope.username;
                                $scope.myName = passData.userInfo.username;
                                $scope.comSet[0].state = true;
                                passData.userInfo.comRank = $scope.comSet[0].state;
                            } else {
                                $scope.header = "Choose user name";
                                $scope.message = "Sorry, the user name\n\n" + $scope.username + '\n\nis taken, please try another.';
                                var modalInstance = $uibModal.open({
                                    animation: $scope.animationsEnabled,
                                    templateUrl: 'modalOK.html',
                                    controller: ModalInstanceCtrl,
                                    scope: $scope
                                });
                            }
                        }
                    }, function (data) {
                        // console.log("couldn't get username");
                        $scope.header = "Choose user name";
                        $scope.message = "Sorry, could not chek user name, please try again";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                    });
        } else {
            $scope.header = "Choose user name";
            $scope.message = "Please enter a user name";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });

        }
    };
    $scope.submit = function () {
        //console.log("in submit");
        passData.userInfo.emChaMe = $scope.emailSet[0].state;
        passData.userInfo.emPickSum = $scope.emailSet[1].state;
        passData.userInfo.emChaSum = $scope.emailSet[2].state;
        passData.userInfo.comRank = $scope.comSet[0].state;
//        passData.userInfo.comChaAll = $scope.comSet[1].state;
        var settingStr = JSON.stringify({emailSet: $scope.emailSet,
            comSet: $scope.comSet,
            userId: GuserInfo.Id});
        var postData = "{\"setting\":".concat(settingStr).concat("}");
        $http.post(AUSOMESPORTS_API + 'op=setting', postData)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                    $scope.header = "Settings";
                    $scope.message = "Your settings have been saved";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                }, function (data) {
                    $scope.header = "Settings";
                    $scope.message = "Sorry, there was an error saving your settings";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                });
    };
    $scope.chInput = function () {
        $scope.chCnt = $scope.chMax - $scope.username.length;
    };
}
function friendCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    ctrlInit("Friends", $scope, $location, $route, $timeout);
    $scope.showAddFriend = false;
    $scope.friendsData = {};
    $scope.friendsData.friend = passData.friend;
    if ($scope.friendsData.friend) {
        for (var i = 0; i < $scope.friendsData.friend.length; i++) {
            $scope.friendsData.friend[i].showEdFriend = false;
            $scope.friendsData.friend[i].showRmFriend = false;
        }
    }
    $scope.chName = {new : ""};

    $scope.addFriend = function () {
        if ($scope.showAddFriend) {
            $scope.showAddFriend = false;
        } else {
            $scope.showAddFriend = true;
        }
    };
    $scope.submitFriend = function () {
        //console.log("add friend: " + $scope.name + "(" + $scope.email + ")");
        if (!$scope.name || !$scope.email) {
            $scope.header = "Add Friend";
            $scope.message = 'Please provide name, and email';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
        var email = $scope.email.toLowerCase();
        email = email.replace(/\s+/g, '');
        if ($scope.friendsData.friend) {
            for (var i = 0; i < $scope.friendsData.friend.length; i++) {
                if ($scope.friendsData.friend[i].userEmail === email) {
                    $scope.header = "Add Friend";
                    $scope.message = "A Friend with email " + $scope.email
                            + " already exist in your friends list";
                    var modalInstance = $uibModal.open({
                        animation: $scope.animationsEnabled,
                        templateUrl: 'modalOK.html',
                        controller: ModalInstanceCtrl,
                        scope: $scope
                    });
                    return;
                }
            }
        }
        if (ValidateEmail(email)) {
            var postData = "{\"invite\":{";
            postData = postData.concat("\"userID\":\"" + GuserInfo.Id + "\",");
            postData = postData.concat("\"userName\":\"" + GuserInfo.Name + "\",");
            postData = postData.concat("\"userEmail\":\"" + GuserInfo.Email + "\",");
            postData = postData.concat("\"name\":\"" + $scope.name + "\",");
            postData = postData.concat("\"status\":\"" + "pending" + "\",");
            postData = postData.concat("\"email\":\"" + email + "\"");
            postData = postData.concat("}}");
            $http.post(AUSOMESPORTS_API + 'op=invite', postData)
                    .then(function (data) {
                        if (data.data.version) {
                            $location.path("/update");
                        }
                        return;
                    }, function (data) {
                        $scope.header = "Add Friend";
                        $scope.message = "Sorry, problem adding friend";
                        var modalInstance = $uibModal.open({
                            animation: $scope.animationsEnabled,
                            templateUrl: 'modalOK.html',
                            controller: ModalInstanceCtrl,
                            scope: $scope
                        });
                        return;
                    });
            var findex;
            if (passData.friend) {
                findex = passData.friend.length + 1;
            } else {
                findex = 0;
            }
            var newFriend = {"userID": "tbd",
                "userName": $scope.name,
                "userEmail": email,
                "index": findex};
            if ($scope.friendsData.friend) {
                $scope.friendsData.friend.unshift(newFriend);
            } else {
                $scope.friendsData.friend = [newFriend];
            }
            passData.friend = $scope.friendsData.friend;
            $scope.header = "Add Friend";
            $scope.message = "Friend \b"
                    + $scope.name
                    + "\n(" + $scope.email
                    + ")\n has been added to your friends list";
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });

        } else {
            $scope.header = "Add Friend";
            $scope.message = 'Bad email format; example format abc@xyz.com';
            var modalInstance = $uibModal.open({
                animation: $scope.animationsEnabled,
                templateUrl: 'modalOK.html',
                controller: ModalInstanceCtrl,
                scope: $scope
            });
            return;
        }
    };
    $scope.rmFriendFlag = function (index) {
        $scope.friendsData.friend[index].showEdFriend = false;
        if ($scope.friendsData.friend[index].showRmFriend) {
            $scope.friendsData.friend[index].showRmFriend = false;
        } else {
            $scope.friendsData.friend[index].showRmFriend = true;
        }
    };
    $scope.edFriendFlag = function (index) {
        $scope.friendsData.friend[index].showRmFriend = false;
        if ($scope.friendsData.friend[index].showEdFriend) {
            $scope.friendsData.friend[index].showEdFriend = false;
        } else {
            $scope.friendsData.friend[index].showEdFriend = true;
        }
    };
    $scope.removeFriend = function (index, confirm) {
        $scope.friendsData.friend[index].showRmFriend = false;
        if (confirm) {
            $http.get(AUSOMESPORTS_API
                    + "op=removeFriend&userID="
                    + GuserInfo.Id
                    + "&email="
                    + $scope.friendsData.friend[index].userEmail)
                    .then(function (data) {
                    }, function (data) {
                    });
            $scope.friendsData.friend.splice(index, 1);
            passData.friend = $scope.friendsData.friend;
        }
    };
    $scope.editFriend = function (index, confirm) {
        if (confirm) {
            if ($scope.friendsData.friend[index].userName !== $scope.chName.new) {
                $scope.friendsData.friend[index].userName = $scope.chName.new;
                passData.friend = $scope.friendsData.friend;
                $http.get(AUSOMESPORTS_API
                        + "op=updateFriendName&userID="
                        + GuserInfo.Id
                        + "&email="
                        + $scope.friendsData.friend[index].userEmail
                        + "&username="
                        + $scope.chName.new)
                        .then(function (data) {
                        }, function (data) {
                        });
            }
        }
        $scope.friendsData.friend[index].showEdFriend = false;
    };

}
function commentCtrl($scope, $http, $location, $uibModal, $route, $timeout) {
    ctrlInit("Comments", $scope, $location, $route, $timeout);
    $scope.chMax = 200;
    $scope.chCnt = $scope.chMax;
    $scope.commentTxt = "";
    $scope.submit = function () {
        //console.log("Comment: " + $scope.commentTxt);
        var commentStr = JSON.stringify({
            text: $scope.commentTxt,
            userId: GuserInfo.Id,
            email: GuserInfo.Email,
            name: GuserInfo.Name
        });
        var postData = "{\"comment\":".concat(commentStr).concat("}");
        $http.post(AUSOMESPORTS_API + 'op=comment', postData)
                .then(function (data) {
                    if (data.data.version) {
                        $location.path("/update");
                        return;
                    }
                }, function (data) {
                });
        $scope.header = "Comments";
        $scope.message = "Thanks for your comments";
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: 'modalDone.html',
            controller: ModalInstanceCtrl,
            scope: $scope
        });
    };
    $scope.chInput = function () {
        $scope.chCnt = $scope.chMax - $scope.commentTxt.length;
    };
}

function signOutCtrl($http, $scope, $location, $route, $timeout) {
    ctrlInit("Sign Out", $scope, $location, $route, $timeout);

    $scope.showSignOut = true;
    $scope.signOut = function () {
        if (nidSave !== "") {
            $http.get(AUSOMESPORTS_API
                    + "op=signOut&userID="
                    + GuserInfo.Id
                    + "&notificationID="
                    + nidSave
                    + "&platform="
                    + platform)
                    .then(function (data) {
                    }, function (data) {
                    });
        }
        window.open('https://accounts.google.com/logout', '_blank', 'menubar=yes');
        $scope.showSignOut = false;
        resetUserInfo();
    };
    $scope.cont = function () {
        $location.path("/appStart");
    };
}

function TourCtrl($scope, $location, $route, $timeout) {
    $scope.myInterval = 10000;
    $scope.noWrapSlides = false;
    $scope.noTrans = false;
    $scope.active = 0;
    var slides = $scope.slides = [
        {image: 'img/tour/intro.png', id: 0, title: 'Introduction'},
        {image: 'img/tour/homepage.png', id: 1, title: 'Homepage'},
        {image: 'img/tour/pick.png', id: 2, title: 'Pick Winners'},
        {image: 'img/tour/mypicks.png', id: 3, title: 'My Picks'},
        {image: 'img/tour/challenge.png', id: 4, title: 'Challenges'},
        {image: 'img/tour/topNav.png', id: 5, title: 'Top Navigation'}
    ];

    $scope.done = function () {
        $location.path("/appStart");
    };
    $scope.nextSlide = function () {
        $scope.active = ($scope.active + 1) % $scope.slides.length;
    };
    $scope.prevSlide = function () {
        if ($scope.active === 0) {
            $scope.active = $scope.slides.length - 1;
        } else {
            $scope.active = ($scope.active - 1) % $scope.slides.length;
        }
    };
}
function ModalInstanceCtrl($scope, $location, $uibModalInstance) {
    $scope.selected = {
    };
    $scope.ok = function () {
        $uibModalInstance.close("ok");
    };
    $scope.done = function () {
        $uibModalInstance.close("done");
        window.history.back();
    };
    $scope.noti = function (type) {
        $uibModalInstance.close("redirect");
        if (type === "accept") {
            $location.path("/getChallenges/true");
        } else if (type === "challenge") {
            $location.path("/getChallenges/false");
        } else if (type === "talk") {
            $location.path("/talk");
        }
    };
    $scope.cancel = function () {
        $uibModalInstance.close("close");
    };
    $scope.yes = function () {
        $uibModalInstance.close("yes");
    };
    $scope.no = function () {
        $uibModalInstance.close("no");
    };
}
;
function adsCtrl($scope, $http, $uibModalInstance) {
    $http.get(AUSOMESPORTS_API
            + "op=getAd&sport="
            + $scope.sport
            + "&team="
            + $scope.team)
            .then(function (data) {
                if (data.data.version) {
                    $location.path("/update");
                    return;
                }
                if (data) {
                    $scope.adData = data.data;
                }
            }, function (data) {
                //console.log("couldn't get ad");
            });
    $scope.close = function () {
        $uibModalInstance.close();
    };
    $scope.details = function (index) {
        window.open($scope.adData.ads[index].detailUrl, '_blank', 'menubar=yes');
    };
}
;

function updateCtrl($scope, $http, $uibModal, $timeout) {
    currentScope = $scope;
    //console.log("old app version");
    $http.get("http://itunes.apple.com/lookup?bundleId=com.shopausome.ausomesports")
            .then(function (data) {
                //               alert("got bundle info: " + JSON.stringify(data));
                var trackid = data.data.results[0].trackId;
                //               alert("got track id: " + trackid);
                $scope.appLink = "http://itunes.apple.com/app/id" + trackid;
            }, function (data) {
                $scope.header = "Update";
                $scope.message = "Open the App Store app and search for Ausome Sports.";
                var modalInstance = $uibModal.open({
                    animation: $scope.animationsEnabled,
                    templateUrl: 'modalOK.html',
                    controller: ModalInstanceCtrl,
                    scope: $scope
                });
            });

    $scope.appleUpdate = function () {
        //       alert("In apple update");
        //       window.open = ($scope.appLink, '_blank', 'menubar=yes');
        $scope.header = "Update";
        $scope.message = "Open the App Store app and search for Ausome Sports.";
        var modalInstance = $uibModal.open({
            animation: $scope.animationsEnabled,
            templateUrl: 'modalOK.html',
            controller: ModalInstanceCtrl,
            scope: $scope
        });
    };
}