'use strict';

/* Services */

angular.module('historyServices', ['ngResource']).
        factory('history', function() {
    var items = [];
    var historyList = {};

    historyList.restore = function() {
        if (localStorage.SaveHistory) {
            var SaveHistory = localStorage.SaveHistory;
            items = angular.fromJson(SaveHistory);
        }
    };

    historyList.addItem = function(item) {
        items.unshift(item);
        var SaveHistory = angular.toJson(items);
        localStorage.SaveHistory = SaveHistory;
    };
    historyList.removeItem = function(index) {
        //      var index = items.indexOf(item);
        items.splice(index, 1);
    };
    historyList.removeAllItems = function() {
        items = [];
        var SaveHistory = angular.toJson(items);
        localStorage.SaveHistory = SaveHistory;
    };
    historyList.items = function() {
        return items;
    };

    return historyList;
});